<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

// Connexion (tous utilisateurs)
if ( isset($_REQUEST['login']) && isset($_REQUEST['motdepasse']) )  {
  $mysqli = connectsql();
  // Récupération des logins/mdp dans la base MySQL et comparaison
  $motdepasse = sha1($_REQUEST['motdepasse']);
  $resultat = $mysqli->query("SELECT id, login, autorisation, matieres, timeout FROM utilisateurs WHERE mdp = '$motdepasse'");
  while ( $r = $resultat->fetch_assoc() )
    if ( $r['login'] == $_REQUEST['login'] )  {
      // Interdiction de garder son identifiant de session
      session_regenerate_id(true);
      $_SESSION = array();
      // Interdiction de pouvoir se connecter aux autres site sur le même serveur
      $_SESSION[md5("$site")] = true;
      // Pour vérification/utilisation aux connexions ultérieures
      $_SESSION['client'] = $_SERVER['HTTP_USER_AGENT'];
      $_SESSION['ip'] = $_SERVER['REMOTE_ADDR'];
      $_SESSION['login'] = $_POST['login'];
      $_SESSION['id'] = $r['id'];
      $_SESSION['autorisation'] = $autorisation = $r['autorisation'];
      $_SESSION['matieres'] = $r['matieres'];
      $_SESSION['timeout'] = $r['timeout'];
      $_SESSION['time'] = time()+$_SESSION['timeout']+14400*($_SESSION['timeout'] == 0);
      // Pour sécurisation des requêtes AJAX
      $_SESSION['csrf-token'] = ( isset($_REQUEST['csrf-token']) ) ? $_REQUEST['csrf-token'] : md5(uniqid(rand(), true)); 
      break;
    }
  $resultat->free();
  $mysqli->close();
  if ( !$autorisation )
    exit('{"etat":"login_nok","message":"Mauvais couple identifiant/mot de passe"}');
  // Si paramètre "connexion", appel par le bouton de connexion (et non
  // reconnexion après requête AJAX). Recharge immédiate, donc $_SESSION
  if ( isset($_REQUEST['connexion']) )
    exit($_SESSION['message'] = '{"etat":"ok","message":"Connexion réussie"}');
}
// Demande de déconnexion (tous utilisateurs)
if ( isset($_REQUEST['deconnexion']) )  {
  // Suppression du cookie et des données de session
  $_SESSION = array();
  setcookie(session_name(),'',time()-3600);
  session_regenerate_id(true);
  // Recharge immédiate, donc besoin de $_SESSION['message']
  exit($_SESSION['message'] = '{"etat":"ok","message":"Déconnexion réussie"}');
}
// Vérification du token CSRF
if ( !isset($_REQUEST['csrf-token']) || isset($_SESSION['csrf-token']) && ( $_REQUEST['csrf-token'] != $_SESSION['csrf-token'] ) )
  exit('{"etat":"nok","message":"Accès non autorisé"}');
// Si non autorisé, la session a dû expirer : il faut se reconnecter
if ( !$autorisation )
  exit( ( isset($_REQUEST['recupdoc']) ) ? '{"etat":"login_"}' : '{"etat":"login"}');
// Connexion à la base de données
$mysqli = connectsql(true);
  
//////////////////////////////////////////////////////
// Préférences : accès élève, colleur et professeur //
//////////////////////////////////////////////////////
if ( ( $autorisation > 1 ) and isset($_REQUEST['prefs']) )  { 
  // Premier cadre de modifications de prefs.php
  if ( isset($_REQUEST['prenom']) && isset($_REQUEST['nom']) && isset($_REQUEST['mail1']) && isset($_REQUEST['mail2']) && isset($_REQUEST['mdp']) )  {
    $resultat = $mysqli->query("SELECT mdp, mail FROM utilisateurs WHERE id = ${_SESSION['id']}");
    $s = $resultat->fetch_assoc();
    $resultat->free();
    $requete_mail = '';
    if ( sha1($_REQUEST['mdp']) != $s['mdp'] )
      $message = '{"etat":"nok","message":"Mot de passe incorrect"}';
    elseif ( !strlen($prenom = trim($_REQUEST['prenom'])) || !strlen($nom = trim($_REQUEST['nom'])) || !strlen($mail = strtolower(trim($_REQUEST['mail1']))) )
      $message = '{"etat":"nok","message":"Votre compte n\'a pas pu être modifié. Prénom, nom et adresse mail non vides nécessaires."}';
    elseif ( ( $mail != $s['mail'] ) && strlen($_REQUEST['mail2']) )  {
      if ( !filter_var($mail,FILTER_VALIDATE_EMAIL) )
        $message = '{"etat":"nok","message":"Adresse mail non valide"}';
      elseif ( $mail != $_REQUEST['mail2'] )
        $message = '{"etat":"nok","message":"Adresses mails différentes"}';
      else  {
        // Vérification que l'adresse n'existe pas déjà
        $resultat = $mysqli->query("SELECT GROUP_CONCAT(mail) AS mails FROM utilisateurs WHERE id != ${_SESSION['id']} AND LENGTH(mail)");
        $s = $resultat->fetch_assoc();
        $resultat->free();
        if ( in_array($mail,explode(',',$s['mails'])) )
          $message = '{"etat":"nok","message":"Adresse mail déjà prise"}';
        else 
          $requete_mail = ', mail = \''.$mysqli->real_escape_string($mail).'\'';
      }
    }
    if ( !strlen($message) )  {
      $prenom = ucfirst($mysqli->real_escape_string($prenom));
      $nom = ucfirst($mysqli->real_escape_string($nom));
      $message = ( requete('utilisateurs',"UPDATE utilisateurs SET nom = '$nom', prenom = '$prenom'$requete_mail WHERE id = ${_SESSION['id']}",$mysqli) ) ? '{"etat":"ok","message":"Préférences modifiées"}' : '{"etat":"nok","message":"Votre compte n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
    }
  }
  // Deuxième cadre de modifications de prefs.php
  elseif ( isset($_REQUEST['login']) && isset($_REQUEST['mdp1']) && isset($_REQUEST['mdp2']) && isset($_REQUEST['timeout']) && isset($_REQUEST['mdp']) && ctype_digit($timeout = $_REQUEST['timeout']) )  {
    $resultat = $mysqli->query("SELECT mdp FROM utilisateurs WHERE id = ${_SESSION['id']}");
    $s = $resultat->fetch_assoc();
    $resultat->free();
    $requete_login = '';
    if ( sha1($_REQUEST['mdp']) != $s['mdp'] )
      $message = '{"etat":"nok","message":"Mot de passe incorrect"}';
    if ( !strlen($login = trim($_REQUEST['login'])) )
      $message = '{"etat":"nok","message":"Votre compte n\'a pas pu être modifié. Identifiant non vide nécessaire."}';
    elseif ( strlen($mdp1 = $_REQUEST['mdp1']) && ( $mdp1 != $_REQUEST['mdp2'] ) )
      $message = '{"etat":"nok","message":"Nouveau mot de passe et confirmation différents"}';
    elseif ( $login != $_SESSION['login'] )  {
      // Vérification que le login n'existe pas déjà
      $resultat = $mysqli->query("SELECT GROUP_CONCAT(login) AS logins FROM utilisateurs WHERE id != ${_SESSION['id']}");
      $s = $resultat->fetch_assoc();
      $resultat->free();
      if ( in_array($login,explode(',',$s['logins'])) )
        $message = '{"etat":"nok","message":"Adresse mail déjà prise"}';
      else 
        $requete_login = ', login = \''.$mysqli->real_escape_string($login).'\'';
    }
    if ( !strlen($message) )  {
      $requete_mdp = ( strlen($mdp1) ) ? ', mdp = "'.sha1($mdp1).'"' : '';
      if ( requete('utilisateurs',"UPDATE utilisateurs SET timeout = $timeout$requete_login$requete_mdp WHERE id = ${_SESSION['id']}",$mysqli) )  {
        $message = '{"etat":"ok","message":"Préférences modifiées"}';
        if ( strlen($requete_login) )
          $_SESSION['login'] = $login;
      }
      else
        $message = '{"etat":"nok","message":"Votre compte n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
    }
  }
}

if ( $autorisation > 2 )  {
/////////////////////////////////////////
// Accès colleur et professeur : notes //
/////////////////////////////////////////
  if ( ( isset($_REQUEST['notes']) or isset($_REQUEST['supprime']) and ( $_REQUEST['table'] == 'notes' ) ) and isset($_REQUEST['id']) and preg_match('/\d*-\d*/',$_REQUEST['id']) )  {
    // id : semaine-matiere
    list($semaine,$matiere) = explode('-',$_REQUEST['id']);

    // Vérification que l'identifiant est valide
    $resultat = $mysqli->query("SELECT SUM(colleur = ${_SESSION['id']}) AS n, GROUP_CONCAT(IF(colleur != ${_SESSION['id']},n.eleve,NULL)) AS eleves
                                FROM semaines AS s LEFT JOIN (SELECT * FROM notes WHERE matiere = $matiere) AS n ON n.semaine = s.id
                                WHERE s.id = $semaine AND s.colle GROUP BY s.id");
    if ( in_array($matiere,explode(',',$_SESSION['matieres'])) && ( $resultat->num_rows ) )  {
      $r = $resultat->fetch_assoc();
      $resultat->free();
      // Suppression
      if ( isset($_REQUEST['supprime']) )
        $message = ( requete('notes',"DELETE FROM notes WHERE semaine = $semaine AND colleur = ${_SESSION['id']} AND matiere = $matiere",$mysqli) ) ? "{\"etat\":\"ok\",\"message\":\"${r['n']} notes supprimées\"}" : '{"etat":"nok","message":"Les notes à supprimer n\'ont pas pu l\'être. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

      // Ajout/Modification
      else  {
        $dejanotes = explode(',',$r['eleves']);
        $effacer = $r['n'];
        // Récupération des élèves associés à la matière
        $resultat = $mysqli->query("SELECT GROUP_CONCAT(id) FROM utilisateurs WHERE autorisation = 2 AND FIND_IN_SET($matiere,matieres)");
        $r = $resultat->fetch_row();
        $resultat->free();
        $eleves = explode(',',$r[0]);
        $notes = array('0','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','0,5','1,5','2,5','3,5','4,5','5,5','6,5','7,5','8,5','9,5','10,5','11,5','12,5','13,5','14,5','15,5','16,5','17,5','18,5','19,5','abs');
        $requete = array();
        // Vérification des notes envoyées et préparation de la requête
        foreach ( $_REQUEST AS $eleve => $note )
          if ( in_array($eleve=substr($eleve,1),$eleves) && in_array($note, $notes,true) && !in_array($eleve,$dejanotes) )
            $requete[] = "($semaine,$eleve,${_SESSION['id']},$matiere,'$note')";
        // Suppression des notes de la semaine à modifier
        if ( $effacer )
          requete('notes',"DELETE FROM notes WHERE semaine = $semaine AND colleur = ${_SESSION['id']} AND matiere = $matiere",$mysqli);
        // Ajout
        $message = $_SESSION['message'] = requete('notes','INSERT INTO notes (semaine,eleve,colleur,matiere,note) VALUES '.implode(',',$requete),$mysqli) ? '{"etat":"ok","message":"'.count($requete).' notes '.(($effacer)?'modifiées':'ajoutées').'"}' : '{"etat":"nok","message":"Aucune note n\'a pu être ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      }
      // Mise à jour des champs 'notes' dans la table 'matieres' (pour le menu)
      $mysqli->query('UPDATE matieres SET notes = IF((SELECT id FROM notes WHERE matiere = matieres.id LIMIT 1),1,0)');
    }
    else 
      $message = '{"etat":"nok","message":"Identifiant non valide"}';
  }

//////////////////////////////////////////////////////////////////
// Accès colleur et professeur : mailexp, mail (depuis mail.php)//
//////////////////////////////////////////////////////////////////
  elseif ( isset($_REQUEST['table']) and ( $_REQUEST['table'] == 'mailprefs' ) && isset($_REQUEST['champ']) && isset($_REQUEST['val']) )  {
    if ( !strlen($val = $_REQUEST['val']) )
      $message = '{"etat":"nok","message":"Cette valeur ne peut pas être vide."}';
    elseif ( $_REQUEST['champ'] == 'mailexp' )
      $message = ( requete('utilisateurs','UPDATE utilisateurs SET mailexp = "'.$mysqli->real_escape_string($val)."\" WHERE id = ${_SESSION['id']}",$mysqli) ) ? '{"etat":"ok","message":"Nom d\'expéditeur modifié"}' : '{"etat":"nok","message":"Le nom d\'expéditeur n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
    elseif ( ( $_REQUEST['champ'] == 'mailcopy' ) && in_array($val,array(0,1)) )
      $message = ( requete('utilisateurs',"UPDATE utilisateurs SET mailcopy = $val WHERE id = ${_SESSION['id']}",$mysqli) ) ? '{"etat":"ok","message":"Mise en copie modifiée"}' : '{"etat":"nok","message":"La mise en copie n\'a pas pu être modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
    else  {
      if ( !filter_var($val,FILTER_VALIDATE_EMAIL) )
        $message = '{"etat":"nok","message":"Adresse mail non valide"}';
      else  {
        // Mail : vérification qu'il n'existe pas déjà
        $resultat = $mysqli->query("SELECT GROUP_CONCAT(mail) AS mails FROM utilisateurs WHERE id != ${_SESSION['id']} AND LENGTH(mail)");
        $s = $resultat->fetch_assoc();
        $resultat->free();
        if ( in_array($mail = strtolower($mysqli->real_escape_string($val)),explode(',',$s['mails'])) )
          $message = '{"etat":"nok","message":"Adresse mail déjà prise"}';
        elseif ( requete('utilisateurs',"UPDATE utilisateurs SET mail = '$mail' WHERE id = ${_SESSION['id']}",$mysqli) )
          $message = '{"etat":"ok","message":"Adresse mail modifiée"}';
      }
    }
  }

/////////////////////////////////////////////////
// Accès colleur et professeur : envoi de mail //
/////////////////////////////////////////////////
  elseif ( isset($_REQUEST['envoimail']) && isset($_REQUEST['id-copie']) && isset($_REQUEST['sujet']) && isset($_REQUEST['texte'])  )  {
    // Récupération des données de l'utilisateur courant
    $resultat = $mysqli->query("SELECT mailexp, mail FROM utilisateurs WHERE id = ${_SESSION['id']}");
    $u = $resultat->fetch_assoc();
    $resultat->free();
    // Récupération des destinataires
    $resultat = $mysqli->query("SELECT id, IF(LENGTH(nom),CONCAT(nom,' ',prenom),login) AS nom, mail
                                FROM utilisateurs WHERE LENGTH(mail) AND LENGTH(mdp)=40 AND id != ${_SESSION['id']} ORDER BY autorisation DESC, nom");
    while ( $r = $resultat->fetch_assoc() )
      $utilisateurs[$r['id']] = $r;
    $resultat->free();
    $dests = '';
    $ids = explode(',',$_REQUEST['id-copie']);
    foreach ( $ids as $i )
      if ( isset($utilisateurs[$i]) )  {
        $dests .= $utilisateurs[$i]['nom'].' <'.$utilisateurs[$i]['mail'].'>, ';
        unset($utilisateurs[$i]);
      }
    if ( !strlen($dests) )
      $message = '{"etat":"nok","message":"Pas de destinataire valide : mail non envoyé"}';
    elseif ( !strlen($sujet = $_REQUEST['sujet']) )
      $message = '{"etat":"nok","message":"Pas de sujet : mail non envoyé"}';
    elseif ( !strlen($texte = $_REQUEST['texte']) )
      $message = '{"etat":"nok","message":"Pas de texte : mail non envoyé"}';
    else  {
      $dests = substr($dests,0,-2);
      $bcc = ( isset($_REQUEST['copie']) ) ? "${u['mailexp']} <${u['mail']}>, " : '';
      if ( isset($_REQUEST['id-bcc']) )
        $ids = explode(',',$_REQUEST['id-bcc']);
        foreach ( $ids as $i )
          if ( isset($utilisateurs[$i]) )  {
            $bcc .= $utilisateurs[$i]['nom'].' <'.$utilisateurs[$i]['mail'].'>, ';
            unset($utilisateurs[$i]);
          }
      $bcc = ( strlen($bcc) ) ? 'Bcc: '.substr($bcc,0,-2) : '';
      mail($dests,'=?UTF-8?B?'.base64_encode($sujet).'?=',$texte,'From: =?UTF-8?B?'.base64_encode($u['mailexp'])."?= <${u['mail']}>\r\nContent-type: text/plain; charset=UTF-8\r\n$bcc","-f${u['mail']}");
      
      // Message de confirmation d'envoi
      $n1 = substr_count($dests,'<');
      $n2 = substr_count($bcc,'<') - isset($_REQUEST['copie']);
      if ( $n2 )
        $message = 'Mail envoyé à '.($n1+$n2).' destinataires (dont '.$n2.' en copie cachée)';
      else
        $message = ( $n1 > 1 ) ? "Mail envoyé à $n1 destinataires." : 'Mail envoyé à 1 destinataire';
      $message = $_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"$message\"}";
    }
  }
}

/////////////////////////////////
// Accès professeur uniquement //
/////////////////////////////////
if ( $autorisation < 4 )  {
  $mysqli->close();
  if ( !strlen($message) )
    $message = '{"etat":"nok","message":"Aucune action effectuée"}';
  exit($message);
}

///////////////////////////////////////////////
// Récupération des répertoires et documents //
///////////////////////////////////////////////
if ( isset($_REQUEST['recupdoc']) )  {
  $mats = '<option value="-1">[Choisissez une matière]</option>';
  $reps = array( -1 =>'<option value="-1">[Choisissez une matière]</option>');
  $docs = array( -1 => '<option value="0">[Choisissez une matière]</option>', 0 => '<option value="0">[Choisissez un répertoire]</option>' );
  // Récupération des répertoires, avec le chemin complet
  $resultat = $mysqli->query("SELECT r.id, r.nom, r.matiere,
                              CONCAT( ( SELECT GROUP_CONCAT(reps.nom SEPARATOR '/') FROM reps WHERE FIND_IN_SET(reps.id,r.parents) ) ,'/') AS parents
                              FROM reps AS r LEFT JOIN matieres AS m ON m.id = r.matiere
                              WHERE r.nbdoc_v AND FIND_IN_SET(r.matiere,'${_SESSION['matieres']}') ORDER BY m.ordre, CONCAT(parents, r.nom)");
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      if ( !isset($reps[$r['matiere']]) )  {
        $reps[$r['matiere']] = '<option value="0">[Choisissez un répertoire]</option>';
        $mats .= "<option value=\"${r['matiere']}\">".( ( strpos($r['parents'],'/') ) ? strstr($r['parents'],'/',true) : $r['nom'] ).'</option>';
      }
      $reps[$r['matiere']] .= "<option value=\"${r['id']}\">${r['parents']}${r['nom']}</option>";
      // Récupération des documents
      $docs[$r['id']] = '<option value="0">[Choisissez un document]</option>';
      $res = $mysqli->query("SELECT id, nom, SUBSTRING(ext,2) AS ext FROM docs WHERE parent = ${r['id']} AND protection < 5");
      while ( $d = $res->fetch_assoc() )  {
        $docs[$r['id']] .= "<option value=\"${d['id']}\">${d['nom']} (${d['ext']})</option>";
      }
      $res->free();
    }
    $resultat->free();
  }
  $mysqli->close();
  exit(json_encode(array('etat'=>'ok_','mats'=>$mats,'reps'=>$reps,'docs'=>$docs)));
}

/////////////////////////////////////////////////////////////////////////
// Gestion des demandes en fonction de la valeur de $_REQUEST['table'] //
/////////////////////////////////////////////////////////////////////////
if ( isset($_REQUEST['table']) )  {
  // Fonction PHP pour le stockage dans la base MySQL de l'ordre "naturel" (1,2,10,11 et non 1,10,11,2)
  // Remplace tout nombre par un nombre égal mais écrit sur 10 chiffres, complété par des zéros à gauche
  // Utilisé pour les documents et les groupes
  function zpad($s) {
    return preg_replace_callback('/(\d+)/', function($m){
      return(str_pad($m[1],10,'0',STR_PAD_LEFT)); }
    , $s);
  }

switch ( $table = $_REQUEST['table'] )  {
////////////////////////////
// Modification des pages //
////////////////////////////
  case 'pages':

    // Vérification que l'identifiant est valide
    // Changement de matière, suppression et déplacements interdits pour la page d'accueil (id=1)
    if ( isset($_REQUEST['id']) && ( ctype_digit($id = $_REQUEST['id']) ) )  {
      $resultat = $mysqli->query("SELECT ordre, mat, (SELECT COUNT(*) FROM pages WHERE mat = p.mat) AS max FROM pages AS p WHERE id = $id AND FIND_IN_SET(mat,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();

        // Traitement d'une modification globale (depuis index.php ou pages.php)
        if ( isset($_REQUEST['titre']) && isset($_REQUEST['nom']) && isset($_REQUEST['cle']) && isset($_REQUEST['bandeau']) && isset($_REQUEST['protection']) )  {
          if ( !strlen($_REQUEST['titre']) || !strlen($_REQUEST['cle']) || !strlen($_REQUEST['nom']) )
            $message = '{"etat":"nok","message":"La page n\'a pas pu être modifiée. Titre, clé et nom non vides nécessaires."}';
          else  {
            $m = ( isset($_REQUEST['matiere']) && in_array($matiere = $_REQUEST['matiere'],explode(',',$_SESSION['matieres'])) && ( $matiere != $r['mat'] ) && ( $id > 1 ) ) ? ", mat = $matiere" : '';
            $cle = str_replace(' ','_',trim($mysqli->real_escape_string($_REQUEST['cle'])));
            // Vérification que la clé n'existe pas déjà
            $resultat = $mysqli->query("SELECT cle FROM pages WHERE id != $id AND mat = ".( ( strlen($m) ) ? $matiere : $r['mat'] ));
            if ( $resultat->num_rows )  {
              while ( $s = $resultat->fetch_assoc() )
                if ( $s['cle'] == $cle )  {
                  $message = '{"etat":"nok","message":"La page n\'a pas pu être modifiée. Cette clé existe déjà et doit être unique."}';
                  break;
                }
              $resultat->free();
            }
          }
          if ( !strlen($message) )  {
            $titre = trim($mysqli->real_escape_string($_REQUEST['titre']));
            $nom = trim($mysqli->real_escape_string($_REQUEST['nom']));
            $bandeau = trim($mysqli->real_escape_string($_REQUEST['bandeau']));
            $protection = ( in_array($_REQUEST['protection'],array(0,1,2,3,4,5)) ) ? $_REQUEST['protection'] : 0;
            if ( requete('pages',"UPDATE pages SET cle = '$cle', nom = '$nom', titre = '$titre', bandeau = '$bandeau', protection = $protection $m WHERE id = $id",$mysqli) )  {
              $message = $_SESSION['message'] = '{"etat":"ok","message":"Page modifiée"}';
              // Si $_REQUEST[matiere] existe, on vient de pages.php.
              // Sinon de index.php donc rechargement
              if ( !isset($_REQUEST['matiere']) )
                $_SESSION['message'] = $message;
              elseif ( strlen($m) )  {
                requete('pages',"UPDATE pages SET mat = $matiere, ordre = (SELECT COUNT(*) FROM (SELECT id FROM pages AS p WHERE p.mat = $matiere) AS p1)+1 WHERE id = $id",$mysqli);
                requete('pages',"UPDATE pages SET ordre = (ordre-1) WHERE mat = ${r['mat']} AND ordre > ${r['ordre']}",$mysqli);
              }
            }
            else
              $message = '{"etat":"nok","message":"La page n\'a pas pu être modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
          }
        }

        // Déplacement vers le haut
        elseif ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1+!$r['mat'] ) )
          $message = ( requete('pages',"UPDATE pages SET ordre = (2*${r['ordre']}-1-ordre) WHERE mat = ${r['mat']} AND ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) )",$mysqli)
          ) ? '{"etat":"ok","message":"Page déplacée"}' : '{"etat":"nok","message":"La page n\'a pas pu être déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Déplacement vers le bas
        elseif ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) && ( $id > 1 ) )
          $message = ( requete('pages',"UPDATE pages SET ordre = (2*${r['ordre']}+1-ordre) WHERE mat = ${r['mat']} AND ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) )",$mysqli)
          ) ? '{"etat":"ok","message":"Page déplacée"}' : '{"etat":"nok","message":"La page n\'a pas pu être déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Suppression
        elseif ( isset($_REQUEST['supprime']) && ( $id > 1 ) )
          $message = ( requete('pages',"DELETE FROM pages WHERE id = $id",$mysqli)
                    && requete('infos',"DELETE FROM infos WHERE page = $id",$mysqli)
                    && requete('pages',"UPDATE pages SET ordre = (ordre-1) WHERE mat = ${r['mat']} AND ordre > ${r['ordre']}",$mysqli)
          ) ? '{"etat":"ok","message":"Page supprimée"}' : '{"etat":"nok","message":"La page n\'a pas pu être supprimée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Suppression des informations
        elseif ( isset($_REQUEST['supprime_infos']) )
          $message = ( requete('infos',"DELETE FROM infos WHERE page = $id",$mysqli) ) ? '{"etat":"ok","message":"Informations de la page supprimées"}' : '{"etat":"nok","message":"Les informations de la page n\'ont pas pu être supprimées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
          
        $mysqli->query('ALTER TABLE pages ORDER BY mat,ordre');
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }
     
    // Nouvelle page
    elseif ( isset($_REQUEST['titre']) && isset($_REQUEST['nom']) && isset($_REQUEST['cle']) && isset($_REQUEST['bandeau']) && isset($_REQUEST['matiere']) && isset($_REQUEST['protection']) && in_array($matiere = $_REQUEST['matiere'],explode(',',$_SESSION['matieres'])) )  {
      if ( !strlen($_REQUEST['titre']) || !strlen($_REQUEST['cle']) || !strlen($_REQUEST['nom']) )
        $message = '{"etat":"nok","message":"La page n\'a pas pu être ajoutée. Titre, clé et nom non vides nécessaires."}';
      else  {
        $titre = trim($mysqli->real_escape_string($_REQUEST['titre']));
        $bandeau = trim($mysqli->real_escape_string($_REQUEST['bandeau']));
        $cle = str_replace(' ','_',trim($mysqli->real_escape_string($_REQUEST['cle'])));
        $nom = trim($mysqli->real_escape_string($_REQUEST['nom']));
        $protection = ( in_array($_REQUEST['protection'],array(0,1,2,3,4,5)) ) ? $_REQUEST['protection'] : 0;
        // Vérification que la clé n'existe pas déjà
        $resultat = $mysqli->query("SELECT id FROM pages WHERE cle = '$cle' AND mat = $matiere");
        if ( $resultat->num_rows )  {
          $message = '{"etat":"nok","message":"La page n\'a pas pu être ajoutée. Cette clé existe déjà et doit être unique."}';
          $resultat->free();
        }
        else 
          $message = ( requete('pages',"INSERT INTO pages SET cle = '$cle', nom = '$nom', mat = $matiere, titre = '$titre',
                                        bandeau = '$bandeau', protection = $protection, ordre = (SELECT IFNULL(MAX(ordre)+1,1)
                                        FROM pages AS p WHERE p.mat = $matiere)",$mysqli)
          ) ? '{"etat":"ok","message":"Page ajoutée"}' : '{"etat":"nok","message":"La page n\'a pas pu être ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      }
    }
    break;

///////////////////////////////////
// Modification des informations //
///////////////////////////////////
  case 'infos':
  
    // Vérification que l'identifiant est valide
    if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
      $resultat = $mysqli->query("SELECT i.ordre, i.titre, cache, texte, page, cle, protection, mat, ( SELECT COUNT(*) FROM infos WHERE page = i.page ) AS max FROM infos AS i LEFT JOIN pages AS p ON i.page = p.id WHERE i.id = $id AND FIND_IN_SET(p.mat,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();

        // Traitement d'une modification
        if ( isset($_REQUEST['champ']) && in_array($champ = $_REQUEST['champ'],array('titre','texte')) )  {
          $valeur = trim($mysqli->real_escape_string($_REQUEST['val']));
          if ( ( $champ == 'texte' ) && ( !strlen($valeur) ) )
            $message = '{"etat":"nok","message":"L\'information n\'a pas pu être modifiée. Texte non vide nécessaire."}';
          elseif ( requete('infos',"UPDATE infos SET $champ = '$valeur' WHERE id = $id",$mysqli) )  {
            $message = '{"etat":"ok","message":"Information modifiée"}';
            if ( !$r['cache'] )  {
              if ( $champ == 'titre' )
                recent($mysqli,1,$id,array('titre'=>"<span class=\"icon-infos\"></span> $valeur", 'lien'=>".?${r['cle']}", 'texte'=>$r['texte'], 'matiere'=>$r['mat'], 'protection'=>$r['protection']));
              else
                recent($mysqli,1,$id,array('titre'=>"<span class=\"icon-infos\"></span> ${r['titre']}", 'lien'=>".?${r['cle']}", 'texte'=>$valeur, 'matiere'=>$r['mat'], 'protection'=>$r['protection']));
            }
          }
          else
            $message = '{"etat":"nok","message":"L\'information n\'a pas pu être modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Déplacement vers le haut
        elseif ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
          $message = ( requete('infos',"UPDATE infos SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) ) AND page = ${r['page']}",$mysqli)
                    && $mysqli->query('ALTER TABLE infos ORDER BY page,ordre')
          ) ? '{"etat":"ok","message":"Déplacement réalisé"}' : '{"etat":"nok","message":"L\'information n\'a pas pu être déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Déplacement vers le bas
        elseif ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
          $message = ( requete('infos',"UPDATE infos SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) ) AND page = ${r['page']}",$mysqli)
                    && $mysqli->query('ALTER TABLE infos ORDER BY page,ordre')
          ) ? '{"etat":"ok","message":"Déplacement réalisé"}' : '{"etat":"nok","message":"L\'information n\'a pas pu être déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Positionnement "montré" (apparaît sur la partie publique)
        elseif ( isset($_REQUEST['montre']) )  {
          if ( requete('infos',"UPDATE infos SET cache = 0 WHERE id = $id",$mysqli) )  {
            $message = '{"etat":"ok","message":"L\'information apparaît désormais sur la partie publique."}';
            recent($mysqli,1,$id,array('titre'=>"<span class=\"icon-infos\"></span> ${r['titre']}", 'lien'=>".?${r['cle']}", 'texte'=>$r['texte'], 'matiere'=>$r['mat'], 'protection'=>$r['protection']));
          }
          else
            $message = '{"etat":"nok","message":"L\'information n\'a pas pu être diffusée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Positionnement "caché" (n'apparaît pas sur la partie publique)
        elseif ( isset($_REQUEST['cache']) )  {
          if ( requete('infos',"UPDATE infos SET cache = 1 WHERE id = $id",$mysqli) )  {
            $message = '{"etat":"ok","message":"L\'information n\'apparaît plus sur la partie publique mais est toujours disponible ici pour modification ou diffusion."}';
            recent($mysqli,1,$id);
          }
          else
            $message = '{"etat":"nok","message":"L\'information n\'a pas pu être cachée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Suppression
        elseif ( isset($_REQUEST['supprime']) )  {
          if ( requete('infos',"DELETE FROM infos WHERE id = $id",$mysqli) 
            && requete('infos',"UPDATE infos SET ordre = (ordre-1) WHERE ordre > ${r['ordre']} AND page = ${r['page']}",$mysqli) )  {
            $message = '{"etat":"ok","message":"Suppression réalisée"}';
            recent($mysqli,1,$id);
          }
          else
            $message = '{"etat":"nok","message":"L\'information n\'a pas pu être supprimée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }
    
    // Nouvelle information, seulement si page valide
    elseif ( isset($_REQUEST['page']) && ctype_digit($page = $_REQUEST['page']) )  {
      // Vérification de l'identifiant de la page
      $resultat = $mysqli->query("SELECT cle, protection, mat FROM pages WHERE id = $page AND FIND_IN_SET(mat,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();
        // Autres données
        $titre = trim($mysqli->real_escape_string($_REQUEST['titre']));
        $texte = trim($mysqli->real_escape_string($_REQUEST['texte']));
        $cache = ( isset($_REQUEST['cache']) ) ? 1 : 0;
        if ( !strlen($texte) )
          $message = '{"etat":"nok","message":"L\'information n\'a pas pu être ajoutée. Texte non vide nécessaire."}';
        // Écriture
        elseif ( requete('infos',"UPDATE infos SET ordre = (ordre+1) WHERE page = $page",$mysqli)
          && requete('infos',"INSERT INTO infos SET ordre = 1, page = $page, texte = '$texte', titre = '$titre', cache = $cache",$mysqli) )  {
          $message = $_SESSION['message'] = '{"etat":"ok","message":"Information ajoutée"}';
          if ( !$cache )
            recent($mysqli,1,$mysqli->insert_id,array('titre'=>"<span class=\"icon-infos\"></span> $titre", 'lien'=>".?${r['cle']}", 'texte'=>$texte, 'matiere'=>$r['mat'], 'protection'=>$r['protection']));
          $mysqli->query('ALTER TABLE infos ORDER BY page,ordre');
        }
        else
          $message = '{"etat":"nok","message":"L\'information n\'a pas pu être ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }
    break;

///////////////////////////////////////////
// Modification des programmes de colles //
///////////////////////////////////////////
  case 'colles':

    // Vérification que l'identifiant est valide
    // L'identifiant est sous la forme semaine-matiere, pour assurer une
    // cohérence entre les programmes entrées et ceux non entrés/supprimés
    if ( isset($_REQUEST['id']) && ctype_digit($sid = strstr($_REQUEST['id'],'-',true)) && in_array($mid = substr(strstr($_REQUEST['id'],'-'),1), explode(',',$_SESSION['matieres'])) )  {
      $resultat = $mysqli->query("SELECT DATE_FORMAT(s.debut,'%e/%m') AS debut, c.id, c.cache, c.texte
                                  FROM semaines AS s LEFT JOIN colles AS c ON c.semaine = s.id
                                  WHERE s.id = $sid AND c.matiere = $mid");
      // Si résultat : programme de colle déjà existant
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();

        // Traitement d'un ajout/d'une modification
        if ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'texte' ) )  {
          $valeur = $mysqli->real_escape_string($_REQUEST['val']);
          if ( !strlen($valeur) )
            $message = '{"etat":"nok","message":"Le programme de colle n\'a pas pu être modifié. Texte non vide nécessaire."}';
          elseif ( requete('colles',"UPDATE colles SET texte = '$valeur' WHERE id = ${r['id']}",$mysqli) )  {
            $message = '{"etat":"ok","message":"Programme de colles modifié"}';
            if ( !$r['cache'] )  {
              // Fabrication des données pour les informations récentes
              $resultat = $mysqli->query("SELECT nom, cle, colles_protection FROM matieres WHERE id = $mid");
              $s = $resultat->fetch_assoc();
              $resultat->free();
              recent($mysqli,2,$r['id'],array('titre'=>"<span class=\"icon-colles\"></span> Colles du ${r['debut']} en ${s['nom']}", 'lien'=>"colles?${s['cle']}&amp;n=$sid", 'texte'=>$valeur, 'matiere'=>$mid, 'protection'=>$s['colles_protection']));
            }
          }
          else
            $message = '{"etat":"nok","message":"Le programme de colles n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Positionnement "montré" (apparaît sur la partie publique)
        elseif ( isset($_REQUEST['montre']) )  {
          if ( requete('colles',"UPDATE colles SET cache = 0 WHERE id = ${r['id']}",$mysqli) )  {
            $message = '{"etat":"ok","message":"Le programme de colles apparaît désormais sur la partie publique."}';
            // Fabrication des données pour les informations récentes
            $resultat = $mysqli->query("SELECT nom, cle, colles_protection FROM matieres WHERE id = $mid");
            $s = $resultat->fetch_assoc();
            $resultat->free();
            recent($mysqli,2,$r['id'],array('titre'=>"<span class=\"icon-colles\"></span> Colles du ${r['debut']} en ${s['nom']}", 'lien'=>"colles?${s['cle']}&amp;n=$sid", 'texte'=>$r['texte'], 'matiere'=>$mid, 'protection'=>$s['colles_protection']));
          }
          else
            $message = '{"etat":"nok","message":"Le programme de colles n\'a pas pu être diffusé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Positionnement "caché" (n'apparaît pas sur la partie publique)
        elseif ( isset($_REQUEST['cache']) )  {
          if ( requete('colles',"UPDATE colles SET cache = 1 WHERE id = ${r['id']}",$mysqli) )  {
            $message = '{"etat":"ok","message":"Le programme de colles n\'apparaît plus sur la partie publique mais est toujours disponible ici pour modification ou diffusion."}';
            recent($mysqli,2,$r['id']);
          }
          else
            $message = '{"etat":"nok","message":"Le programme de colles n\'a pas pu être caché. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Suppression
        elseif ( isset($_REQUEST['supprime']) )  {
          if ( requete('colles',"DELETE FROM colles WHERE id = ${r['id']}",$mysqli) )  {
            $message = '{"etat":"ok","message":"Suppression réalisée"}';
            recent($mysqli,2,$r['id']);
          }
          else
            $message = '{"etat":"nok","message":"Le programme de colles n\'a pas pu être supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }
      }

      // Si pas de résultat : nouveau programme de colle
      else  {
        $texte = $mysqli->real_escape_string($_REQUEST['texte']);
        $cache = ( isset($_REQUEST['cache']) ) ? 1 : 0;
        if ( !strlen($texte) )
          $message = '{"etat":"nok","message":"Le programme de colles n\'a pas pu être ajouté. Texte non vide nécessaire."}';
        elseif ( requete('colles',"INSERT INTO colles SET texte = '$texte', semaine = $sid, matiere = $mid, cache = $cache",$mysqli) )  {
          $id = $mysqli->insert_id;
          $mysqli->query('ALTER TABLE colles ORDER BY matiere,semaine');
          $message = '{"etat":"ok","message":"Programme de colles ajouté"}';
          if ( !$cache )  {
            // Fabrication des données pour les informations récentes
            $resultat = $mysqli->query("SELECT DATE_FORMAT(debut,'%e/%m') AS debut FROM semaines WHERE id = $sid");
            $r = $resultat->fetch_assoc();
            $resultat->free();
            $resultat = $mysqli->query("SELECT nom, cle, colles_protection FROM matieres WHERE id = $mid");
            $s = $resultat->fetch_assoc();
            $resultat->free();
            recent($mysqli,2,$id,array('titre'=>"<span class=\"icon-colles\"></span> Colles du ${r['debut']} en ${s['nom']}", 'lien'=>"colles?${s['cle']}&amp;n=$sid", 'texte'=>$texte, 'matiere'=>$mid, 'protection'=>$s['colles_protection']));
          }
        }
        else
          $message = '{"etat":"nok","message":"Le programme de colles n\'a pas pu être ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      }
      
      // Mise à jour des champs 'colles' dans la table 'matieres' (pour le menu)
      $mysqli->query('UPDATE matieres SET colles = IF((SELECT id FROM colles WHERE matiere = matieres.id AND cache = 0 LIMIT 1),1,0)');
    }
    else
      $message = '{"etat":"nok","message":"Identifiant non valide"}';
    break;

///////////////////////////////////////
// Modification des cahiers de texte //
///////////////////////////////////////
  case 'cdt':
    // Traitement d'une modification de propriétés/d'un ajout d'élément :
    // validation préliminaire
    if ( isset($_REQUEST['tid']) && isset($_REQUEST['jour']) && ( ctype_digit($tid = $_REQUEST['tid']) ) )  {
      // Validation du jour de la semaine
      $jour = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['jour']);
      $resultat = $mysqli->query("SELECT id FROM semaines WHERE debut <= '$jour' AND ADDDATE(debut,7) >= '$jour' ORDER BY debut DESC LIMIT 1");
      if ( !$resultat->num_rows )
        $message = '{"etat":"nok","message":"Le jour choisi ne se trouve pas dans l\'année scolaire."}';
      else  {
        $r = $resultat->fetch_assoc();
        $semaine = $r['id'];
        $resultat->free();
        // Validation du type de séance
        $resultat = $mysqli->query("SELECT id, deb_fin_pour FROM `cdt-types` WHERE id = $tid AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
        if ( !$resultat->num_rows )
          $message = '{"etat":"nok","message":"Type de séance non valide."}';
        else  {
          $r = $resultat->fetch_assoc();
          $resultat->free();
          // Validation des horaires
          $h_debut = $h_fin = '0:00';
          $pour = '0000/00/00';
          $demigroupe = 0;
          switch ( $r['deb_fin_pour'] )  {
            case 1: $h_fin = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_fin']);
            case 0: $h_debut = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_debut']); $demigroupe = ( in_array($_REQUEST['demigroupe'],array(0,1)) ) ? $_REQUEST['demigroupe'] : 0; break;
            case 2: $pour = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['pour']);
            case 3: $demigroupe = ( in_array($_REQUEST['demigroupe'],array(0,1)) ) ? $_REQUEST['demigroupe'] : 0;
            // Cas 4 et 5 : h_debut, h_fin et pour restent nuls (cf l'aide)
          }
        }
      }
    }

    // Vérification que l'identifiant est valide
    if ( !strlen($message) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
      $resultat = $mysqli->query("SELECT id FROM cdt WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows )  {
        $resultat->free();

        // Traitement d'une modification de propriétés
        if ( isset($h_debut) )  {
          // Écriture dans la base de données
          if ( requete('cdt',"UPDATE cdt SET semaine = $semaine, jour = '$jour', h_debut = '$h_debut', h_fin = '$h_fin',
                              pour = '$pour', type = $tid, demigroupe = $demigroupe WHERE id = $id", $mysqli) )  {
            // Mise en ordre : d'abord ce qui n'a pas de fin, ensuite les
            // séances "normales", ensuite les "pour le"
            $mysqli->query('ALTER TABLE cdt ORDER BY jour,matiere,pour,h_debut,h_fin,type');
            $message = '{"etat":"ok","message":"Élément du cahier de texte modifié"}';
          }
          else
            $message = '{"etat":"ok","message":"Les propriétés de l\'élément du cahier de texte n\'ont pas pu être modifiées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Traitement d'une modification de texte
        elseif ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'texte' ) )  {
          if ( !strlen($valeur = $mysqli->real_escape_string($_REQUEST['val'])) )
            $message = '{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas pu être modifié. Texte non vide nécessaire."}';
          elseif ( requete('cdt',"UPDATE cdt SET texte = '$valeur' WHERE id = $id",$mysqli) )  {
            $message = '{"etat":"ok","message":"Élément du cahier de texte modifié"}';
          }
          else
            $message = '{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Positionnement "montré" (apparaît sur la partie publique)
        elseif ( isset($_REQUEST['montre']) )  {
          if ( requete('cdt',"UPDATE cdt SET cache = 0 WHERE id = $id",$mysqli) )  {
            $message = '{"etat":"ok","message":"L\'élément du cahier de texte apparaît désormais sur la partie publique."}';
          }
          else
            $message = '{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas pu être diffusé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Positionnement "caché" (n'apparaît pas sur la partie publique)
        elseif ( isset($_REQUEST['cache']) )  {
          if ( requete('cdt',"UPDATE cdt SET cache = 1 WHERE id = $id",$mysqli) )  {
            $message = '{"etat":"ok","message":"L\'élément du cahier de texte n\'apparaît plus sur la partie publique mais est toujours disponible ici pour modification ou diffusion."}';
          }
          else
            $message = '{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas pu être caché. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Suppression
        elseif ( isset($_REQUEST['supprime']) )  {
          if ( requete('cdt',"DELETE FROM cdt WHERE id = $id",$mysqli) )  {
            $message = '{"etat":"ok","message":"Suppression réalisée"}';
          }
          else
            $message = '{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas pu être supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }
    
    // Nouvel élément du cahier de texte
    elseif ( !strlen($message) && isset($demigroupe) && isset($_REQUEST['matiere']) && in_array($matiere = $_REQUEST['matiere'], explode(',',$_SESSION['matieres'])) )  {
      $texte = $mysqli->real_escape_string($_REQUEST['texte']);
      $cache = ( isset($_REQUEST['cache']) ) ? 1 : 0;
      if ( !strlen($texte) )
        $message = '{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas pu être ajouté. Texte non vide nécessaire."}';
      elseif ( is_null($h_debut) )
        $message = '{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas pu être ajouté. Horaire de début non vide nécessaire."}';
      elseif ( is_null($h_fin) )
        $message = '{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas pu être ajouté. Horaire de fin non vide nécessaire."}';
      elseif ( is_null($pour) )
        $message = '{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas pu être ajouté. Date d\'échéance non vide nécessaire."}';
      // Écriture dans la base de données
      elseif ( requete('cdt',"INSERT INTO cdt SET matiere = $matiere, semaine = $semaine, jour = '$jour', h_debut = '$h_debut', h_fin = '$h_fin',
                              pour = '$pour', type = $tid, texte = '$texte', demigroupe = $demigroupe, cache = $cache", $mysqli) )  {
        // Mise en ordre : d'abord ce qui n'a pas de fin, ensuite les
        // séances "normales", ensuite les "pour le"
        $mysqli->query('ALTER TABLE cdt ORDER BY jour,matiere,pour,h_debut,h_fin,type');
        $message = $_SESSION['message'] = '{"etat":"ok","message":"Élément du cahier de texte ajouté"}';
      }
      else
        $message = '{"etat":"nok","message":"L\'élément du cahier de texte n\'a pas pu être ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
    }
    
    // Mise à jour des champs 'cdt' dans la table 'matieres' (pour le menu)
    $mysqli->query('UPDATE matieres SET cdt = IF((SELECT id FROM cdt WHERE matiere = matieres.id AND cache = 0 LIMIT 1),1,0)');
    // Mise à jour des champs 'nb' et nb_v dans la table 'cdt-types'
    $mysqli->query('UPDATE `cdt-types` SET
                    nb = (SELECT COUNT(cdt.id) FROM cdt WHERE cdt.type = `cdt-types`.id),
                    nb_v = (SELECT COUNT(cdt.id) FROM cdt WHERE cdt.type = `cdt-types`.id AND cdt.cache = 0)');
    break;

////////////////////////////////////////////////////////////
// Modification des types de séances des cahiers de texte //
////////////////////////////////////////////////////////////
  case 'cdt-types':
  
    // Vérification que l'identifiant est valide
    if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
      $resultat = $mysqli->query("SELECT ordre, titre, nb, cle, matiere, (SELECT COUNT(*) FROM `cdt-types` WHERE matiere = c.matiere) AS max FROM `cdt-types` AS c WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();

        // Traitement d'une modification
        if ( isset($_REQUEST['titre']) && isset($_REQUEST['cle']) && isset($_REQUEST['deb_fin_pour']) )  {
          $titre = ucfirst($mysqli->real_escape_string($_REQUEST['titre']));
          $cle = str_replace(' ','_',trim($mysqli->real_escape_string($_REQUEST['cle'])));
          $deb_fin_pour = ( in_array($_REQUEST['deb_fin_pour'],array(0,1,2,3,4,5)) ) ? $_REQUEST['deb_fin_pour'] : 1;
          if ( !strlen($titre) || !strlen($cle) )
            $message = '{"etat":"nok","message":"Le type de séance n\'a pas pu être modifié. Texte et clé non vides nécessaires."}';
          elseif ( $cle != $r['cle'] )  {
            // Vérification que la clé n'existe pas déjà
            $resultat = $mysqli->query("SELECT cle FROM `cdt-types` WHERE id != $id AND matiere = ${r['matiere']}");
            if ( $resultat->num_rows )  {
              while ( $r = $resultat->fetch_assoc() )
                if ( $r['cle'] == $cle )  {
                  $message = '{"etat":"nok","message":"Le type de séance n\'a pas pu être modifié. Cette clé existe déjà et doit être unique."}';
                  break;
                }
              $resultat->free();
            }
          }
          if ( !strlen($message) )  {
            if ( requete('cdt-types',"UPDATE `cdt-types` SET titre = '$titre', cle = '$cle', deb_fin_pour = $deb_fin_pour WHERE id = $id",$mysqli) )
              $message = $_SESSION['message'] = '{"etat":"ok","message":"Type de séance modifié"}';
            else
              $message = '{"etat":"nok","message":"Le type de séance n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
          }
        }
        
        // Déplacement vers le haut
        elseif ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
          $message = ( requete('cdt-types',"UPDATE `cdt-types` SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) ) AND matiere = ${r['matiere']}",$mysqli)
                    && $mysqli->query('ALTER TABLE `cdt-types` ORDER BY matiere,ordre')
          ) ? '{"etat":"ok","message":"Déplacement réalisé"}' : '{"etat":"nok","message":"Le type de séance n\'a pas pu être déplacé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Déplacement vers le bas
        elseif ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
          $message = ( requete('cdt-types',"UPDATE `cdt-types` SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) ) AND matiere = ${r['matiere']}",$mysqli)
                    && $mysqli->query('ALTER TABLE `cdt-types` ORDER BY matiere,ordre')
          ) ? '{"etat":"ok","message":"Déplacement réalisé"}' : '{"etat":"nok","message":"Le type de séance n\'a pas pu être déplacé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Suppression
        elseif ( isset($_REQUEST['supprime']) )  {
          if ( $r['max'] == 1 )
             $message = '{"etat":"nok","message":"Le type de séance n\'a pas pu être supprimé. Il faut obligatoirement en garder au moins un."}';
          elseif ( requete('cdt',"DELETE FROM cdt WHERE type = $id",$mysqli) && requete('cdt-types',"DELETE FROM `cdt-types` WHERE id = $id",$mysqli) 
            && requete('cdt-types',"UPDATE `cdt-types` SET ordre = (ordre-1) WHERE ordre > ${r['ordre']} AND matiere = ${r['matiere']}",$mysqli) )  {
            $message = '{"etat":"ok","message":"Suppression réalisée"}';
          }
          else
            $message = '{"etat":"nok","message":"Le type de séance n\'a pas pu être supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }
    
    // Nouveau type de séance
    elseif ( isset($_REQUEST['titre']) && isset($_REQUEST['cle']) && isset($_REQUEST['deb_fin_pour']) && isset($_REQUEST['matiere']) && in_array($matiere = $_REQUEST['matiere'],explode(',',$_SESSION['matieres']))  )  {
      $titre = ucfirst($mysqli->real_escape_string($_REQUEST['titre']));
      $cle = str_replace(' ','_',trim($mysqli->real_escape_string($_REQUEST['cle'])));
      $deb_fin_pour = ( in_array($_REQUEST['deb_fin_pour'],array(0,1,2,3,4,5)) ) ? $_REQUEST['deb_fin_pour'] : 1;
      if ( !strlen($titre) || !strlen($cle) )
        $message = '{"etat":"nok","message":"Le type de séance n\'a pas pu être ajouté. Texte et clé non vides nécessaires."}';
      else  {
        // Vérification que la clé n'existe pas déjà
        $resultat = $mysqli->query("SELECT cle FROM `cdt-types` WHERE matiere = $matiere");
        if ( $resultat->num_rows )  {
          while ( $r = $resultat->fetch_assoc() )
            if ( $r['cle'] == $cle )  {
              $message = '{"etat":"nok","message":"Le type de séance n\'a pas pu être ajouté. Cette clé existe déjà et doit être unique."}';
              break;
            }
          $resultat->free();
        }
      }
      if ( !strlen($message) )  {
        if ( requete('cdt-types',"INSERT INTO `cdt-types` SET matiere = $matiere, titre = '$titre', cle = '$cle', deb_fin_pour = $deb_fin_pour,
                                  ordre = (SELECT max(ct.ordre)+1 FROM `cdt-types` AS ct WHERE ct.matiere = $matiere)",$mysqli) )
          $message = $_SESSION['message'] = '{"etat":"ok","message":"Type de séance ajouté"}';
        else
          $message = '{"etat":"nok","message":"Le type de séance n\'a pas pu être ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      }
    }
    break;
    
//////////////////////////////////////////////////////
// Modification des raccourcis des cahiers de texte //
//////////////////////////////////////////////////////
  case 'cdt-seances':
  
    // Vérification que l'identifiant est valide
    if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
      $resultat = $mysqli->query("SELECT ordre, nom, matiere, (SELECT COUNT(*) FROM `cdt-seances` WHERE matiere = c.matiere) AS max FROM `cdt-seances` AS c WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();

        // Traitement d'une modification
        if ( isset($_REQUEST['nom']) && isset($_REQUEST['type']) && ctype_digit($type = $_REQUEST['type']) )  {
          if ( !strlen($nom = $mysqli->real_escape_string($_REQUEST['nom'])) )
            $message = '{"etat":"nok","message":"Le raccourci de séance n\'a pas pu être modifié. Nom non vide nécessaire."}';
          else  {
            $jour = ( in_array($_REQUEST['jour'],array(1,2,3,4,5,6,7)) ) ? $_REQUEST['jour'] : 1;
            // Validation du type de séance
            $resultat = $mysqli->query("SELECT id, deb_fin_pour FROM `cdt-types` WHERE id = $type AND matiere = ${r['matiere']}");
            if ( !$resultat->num_rows )
              $message = '{"etat":"nok","message":"Type de séance non valide."}';
            else  {
              $r = $resultat->fetch_assoc();
              $resultat->free();
              // Validation des horaires
              $h_debut = $h_fin = '0:00';
              $demigroupe = 0;
              switch ( $r['deb_fin_pour'] )  {
                case 1: $h_fin = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_fin']);
                case 0: $h_debut = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_debut']);
                case 2: 
                case 3: $demigroupe = ( in_array($_REQUEST['demigroupe'],array(0,1)) ) ? $_REQUEST['demigroupe'] : 0;
                // Cas 4 et 5 : h_debut, h_fin et pour restent nuls (cf l'aide)
              }
              // Écriture
              if ( requete('cdt-seances',"UPDATE `cdt-seances` SET nom = '$nom', jour = $jour, h_debut = '$h_debut',
                                          h_fin = '$h_fin', type = $type, demigroupe = $demigroupe WHERE id = $id",$mysqli) )
                $message = $_SESSION['message'] = '{"etat":"ok","message":"Raccourci de séance modifié"}';
              else
                $message = '{"etat":"nok","message":"Le raccourci de séance n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
            }
          }
        }
        
        // Déplacement vers le haut
        elseif ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
          $message = ( requete('cdt-seances',"UPDATE `cdt-seances` SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) ) AND matiere = ${r['matiere']}",$mysqli)
                    && $mysqli->query('ALTER TABLE `cdt-seances` ORDER BY matiere,ordre')
          ) ? '{"etat":"ok","message":"Déplacement réalisé"}' : '{"etat":"nok","message":"Le raccourci de séance n\'a pas pu être déplacé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Déplacement vers le bas
        elseif ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
          $message = ( requete('cdt-seances',"UPDATE `cdt-seances` SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) ) AND matiere = ${r['matiere']}",$mysqli)
                    && $mysqli->query('ALTER TABLE `cdt-seances` ORDER BY matiere,ordre')
          ) ? '{"etat":"ok","message":"Déplacement réalisé"}' : '{"etat":"nok","message":"Le raccourci de séance n\'a pas pu être déplacé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Suppression
        elseif ( isset($_REQUEST['supprime']) )  {
          $message = ( requete('cdt-seances',"DELETE FROM `cdt-seances` WHERE id = $id",$mysqli)
                    && requete('cdt-seances',"UPDATE `cdt-seances` SET ordre = (ordre-1) WHERE ordre > ${r['ordre']} AND matiere = ${r['matiere']}",$mysqli)
          ) ? '{"etat":"ok","message":"Suppression réalisée"}' : '{"etat":"nok","message":"Le raccourci de séance n\'a pas pu être supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }
    
    // Nouveau raccourci de séance
    elseif ( isset($_REQUEST['nom']) && isset($_REQUEST['type']) && ctype_digit($type = $_REQUEST['type']) && isset($_REQUEST['matiere']) && in_array($matiere = $_REQUEST['matiere'],explode(',',$_SESSION['matieres'])) )  {
      if ( !strlen($nom = $mysqli->real_escape_string($_REQUEST['nom'])) )
        $message = '{"etat":"nok","message":"Le raccourci de séance n\'a pas pu être ajouté. Nom non vide nécessaire."}';
      else  {
        $jour = ( in_array($_REQUEST['jour'],array(1,2,3,4,5,6,7)) ) ? $_REQUEST['jour'] : 1;
        // Validation du type de séance
        $resultat = $mysqli->query("SELECT id, deb_fin_pour FROM `cdt-types` WHERE id = $type AND matiere = $matiere");
        if ( !$resultat->num_rows )
          $message = '{"etat":"nok","message":"Type de séance non valide."}';
        else  {
          $r = $resultat->fetch_assoc();
          $resultat->free();
          // Validation des horaires
          $h_debut = $h_fin = '0:00';
          $demigroupe = 0;
          switch ( $r['deb_fin_pour'] )  {
            case 1: $h_fin = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_fin']);
            case 0: $h_debut = preg_filter('/(\d{1,2})h(\d{2})/','$1:$2',$_REQUEST['h_debut']);
            case 2: 
            case 3: $demigroupe = ( in_array($_REQUEST['demigroupe'],array(0,1)) ) ? $_REQUEST['demigroupe'] : 0;
            // Cas 4 et 5 : h_debut, h_fin et pour restent nuls (cf l'aide)
          }
          // Écriture
          if ( requete('cdt-seances',"INSERT INTO `cdt-seances` SET matiere = $matiere, nom = '$nom', jour = $jour,
                                      ordre = (SELECT IFNULL(max(cs.ordre)+1,1) FROM `cdt-seances` AS cs WHERE cs.matiere = $matiere),
                                      h_debut = '$h_debut', h_fin = '$h_fin', type = $type, demigroupe = $demigroupe",$mysqli) )
            $message = $_SESSION['message'] = '{"etat":"ok","message":"Raccourci de séance ajouté"}';
          else
            $message = '{"etat":"nok","message":"Le raccourci de séance n\'a pas pu être ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }
      }
    }
    break;

///////////////////////////////
// Modification des matières //
///////////////////////////////
  case 'matieres':

    // Déplacements (possibles pour toute matière, contrairement au reste)
    if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) && ( isset($_REQUEST['monte']) || isset($_REQUEST['descend']) ) )  {
      $resultat = $mysqli->query("SELECT ordre, (SELECT COUNT(*) FROM matieres) AS max FROM matieres WHERE id = $id");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();
        
        // Déplacement vers le haut
        if ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
          $message = ( requete('matieres',"UPDATE matieres SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) )",$mysqli)
                    && $mysqli->query('ALTER TABLE matieres ORDER BY ordre')
          ) ? '{"etat":"ok","message":"Déplacement réalisé"}' : '{"etat":"nok","message":"La matière n\'a pas pu être déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Déplacement vers le bas
        elseif ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
          $message = ( requete('matieres',"UPDATE matieres SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) )",$mysqli)
                    && $mysqli->query('ALTER TABLE matieres ORDER BY ordre')
          ) ? '{"etat":"ok","message":"Déplacement réalisé"}' : '{"etat":"nok","message":"La matière n\'a pas pu être déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }
  
    // Vérification que l'identifiant est valide
    elseif ( isset($_REQUEST['id']) && in_array($id = $_REQUEST['id'],explode(',',$_SESSION['matieres'])) )  {
      $resultat = $mysqli->query("SELECT ordre, cle, nom, colles_protection, cdt_protection, (SELECT COUNT(*) FROM matieres) AS max FROM matieres WHERE id = $id");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();

        // Traitement d'une modification
        if ( isset($_REQUEST['nom']) && isset($_REQUEST['cle']) )  {
          $nom = ucfirst($mysqli->real_escape_string($_REQUEST['nom']));
          $cle = str_replace(' ','_',trim($mysqli->real_escape_string($_REQUEST['cle'])));
          $colles_protection = ( in_array($_REQUEST['colles_protection'],array(0,1,2,3,4,5)) ) ? $_REQUEST['colles_protection'] : 0;
          $cdt_protection = ( in_array($_REQUEST['cdt_protection'],array(0,1,2,3,4,5)) ) ? $_REQUEST['cdt_protection'] : 0;
          if ( !strlen($nom) || !strlen($cle) )
            $message = '{"etat":"nok","message":"La matière n\'a pas pu être modifiée. Nom et clé non vides nécessaires."}';
          elseif ( $cle != $r['cle'] )  {
            // Vérification que la clé n'existe pas déjà
            $resultat = $mysqli->query("SELECT cle FROM matieres WHERE id != $id");
            if ( $resultat->num_rows )  {
              while ( $s = $resultat->fetch_assoc() )
                if ( $s['cle'] == $cle )  {
                  $message = '{"etat":"nok","message":"La matière n\'a pas pu être modifiée. Cette clé existe déjà et doit être unique."}';
                  break;
                }
              $resultat->free();
            }
          }
          if ( !strlen($message) )  {
            if ( requete('matieres',"UPDATE matieres SET nom = '$nom', cle = '$cle', colles_protection = $colles_protection, cdt_protection = $cdt_protection WHERE id = $id",$mysqli) )  {
              $message = $_SESSION['message'] = '{"etat":"ok","message":"Matière modifiée"}';
              if ( $nom != $r['nom'] )
                requete('reps',"UPDATE reps SET nom = '$nom' WHERE matiere = $id AND parent = 0",$mysqli);
            }
            else
              $message = '{"etat":"nok","message":"La matière n\'a pas pu être modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
          }
        }
        
        // Suppression
        elseif ( isset($_REQUEST['supprime']) )  {
          if ( $r['max'] == 1 )
             $message = '{"etat":"nok","message":"La matière n\'a pas pu être supprimée. Il faut obligatoirement en garder au moins une."}';
          elseif ( requete('matieres',"DELETE FROM matieres WHERE id = $id",$mysqli) 
                && requete('matieres',"UPDATE matieres SET ordre = (ordre-1) WHERE ordre > ${r['ordre']}",$mysqli)
                && requete('colles',"DELETE FROM colles WHERE matiere = $id",$mysqli)
                && requete('cdt',"DELETE FROM cdt WHERE matiere = $id",$mysqli)
                && requete('cdt-types',"DELETE FROM `cdt-types` WHERE matiere = $id",$mysqli)
                && requete('cdt-seances',"DELETE FROM `cdt-seances` WHERE matiere = $id",$mysqli)
                && requete('notes',"DELETE FROM notes WHERE matiere = $id",$mysqli)
                && requete('reps',"UPDATE reps SET matiere = 0 WHERE matiere = $id",$mysqli)
                && requete('docs',"UPDATE docs SET matiere = 0 WHERE matiere = $id",$mysqli)
                && requete('pages',"UPDATE pages SET mat = 0 WHERE mat = $id",$mysqli)
                && requete('utilisateurs',"UPDATE utilisateurs SET matieres = TRIM(TRAILING ',' FROM REPLACE(CONCAT(matieres,','),',$id,',',')) ",$mysqli) )
            $message = '{"etat":"ok","message":"Matière '.$r['nom'].' supprimée&nbsp;: programmes de colles, cahier de texte, notes supprimées&nbsp;; répertoires et documents passés dans le répertoire général."}';
          else
            $message = '{"etat":"nok","message":"La matière n\'a pas pu être supprimée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Suppression des programmes de colles d'une matière
        elseif ( isset($_REQUEST['supprime_colles']) )
          $message = ( requete('colles',"DELETE FROM colles WHERE matiere = $id",$mysqli) && requete('matieres',"UPDATE matieres SET colles = 0 WHERE id = $id",$mysqli) ) ? '{"etat":"ok","message":"Programmes de colles en '.$r['nom'].' supprimés"}' : '{"etat":"nok","message":"La suppression n\'a pas été réalisée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        
        // Suppression du cahier de texte d'une matière
        elseif ( isset($_REQUEST['supprime_cdt']) )
          $message = ( requete('cdt',"DELETE FROM cdt WHERE matiere = $id",$mysqli) && requete('matieres',"UPDATE matieres SET cdt = 0 WHERE id = $id",$mysqli) ) ? '{"etat":"ok","message":"Cahier de texte en '.$r['nom'].' supprimés"}' : '{"etat":"nok","message":"La suppression n\'a pas été réalisée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Suppression des notes d'une matière
        elseif ( isset($_REQUEST['supprime_notes']) )
          $message = ( requete('notes',"DELETE FROM notes WHERE matiere = $id",$mysqli) && requete('matieres',"UPDATE matieres SET notes = 0 WHERE id = $id",$mysqli) ) ? '{"etat":"ok","message":"Notes en '.$r['nom'].' supprimés"}' : '{"etat":"nok","message":"La suppression n\'a pas été réalisée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';

        // Suppression des documents d'une matière
        elseif ( isset($_REQUEST['supprime_docs']) )  {
          if ( requete('reps',"DELETE FROM reps WHERE matiere = $id AND parent > 0",$mysqli) )  {
            // Suppression physique
            $resultat = $mysqli->query("SELECT lien FROM docs WHERE matiere = $id");
            if ( $resultat->num_rows )  {
              while ( $r = $resultat->fetch_row() )
                exec("rm -rf documents/${r[0]}");
              $resultat->free();
              requete('docs',"DELETE FROM docs WHERE matiere = $id",$mysqli);
            }
            requete('matieres',"UPDATE matieres SET docs = 0 WHERE id = $id",$mysqli);
            $message = '{"etat":"ok","message":"Documents en '.$r['nom'].' supprimés"}';
          }
        }
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }
    
    // Nouvelle matière
    elseif ( isset($_REQUEST['nom']) && isset($_REQUEST['cle']) && isset($_REQUEST['colles_protection']) && isset($_REQUEST['cdt_protection']) )  {
      $nom = ucfirst($mysqli->real_escape_string($_REQUEST['nom']));
      $cle = str_replace(' ','_',trim($mysqli->real_escape_string($_REQUEST['cle'])));
      $colles_protection = ( in_array($_REQUEST['colles_protection'],array(0,1,2,3,4,5)) ) ? $_REQUEST['colles_protection'] : 0;
      $cdt_protection = ( in_array($_REQUEST['cdt_protection'],array(0,1,2,3,4,5)) ) ? $_REQUEST['cdt_protection'] : 0;
      if ( !strlen($nom) || !strlen($cle) )
        $message = '{"etat":"nok","message":"La matière n\'a pas pu être ajoutée. Nom et clé non vides nécessaires."}';
      else  {
        // Vérification que la clé n'existe pas déjà
        $resultat = $mysqli->query('SELECT cle FROM matieres');
        if ( $resultat->num_rows )  {
          while ( $r = $resultat->fetch_assoc() )
            if ( $r['cle'] == $cle )  {
              $message = '{"etat":"nok","message":"La matière n\'a pas pu être ajoutée. Cette clé existe déjà et doit être unique."}';
              break;
            }
          $resultat->free();
        }
      }
      if ( !strlen($message) )  {
        $resultat = $mysqli->query('SELECT COUNT(*) FROM matieres');
        $r = $resultat->fetch_row();
        $n = $r[0];
        $resultat->free();
        if ( requete('matieres',"INSERT INTO matieres SET nom = '$nom', cle = '$cle', colles_protection = $colles_protection, cdt_protection = $cdt_protection, ordre = ($n+1)",$mysqli) )  {
          $id = $mysqli->insert_id;
          requete('reps',"INSERT INTO reps SET parent = 0, parents = '0', nom = '$nom', matiere = $id,
                          nbrep = 0, nbrep_v = 0, nbdoc = 0, nbdoc_v = 0, protection = 0, menu = 0",$mysqli);
          requete('cdt-types',"INSERT INTO `cdt-types` (matiere, ordre, cle, titre, deb_fin_pour) VALUES
                               ($id, 1, 'cours', 'Cours', 1),
                               ($id, 2, 'TD', 'Séance de travaux dirigés', 1),
                               ($id, 3, 'TP', 'Séance de travaux pratiques', 1),
                               ($id, 4, 'DS', 'Devoir surveillé', 1),
                               ($id, 5, 'interros', 'Interrogation de cours', 0),
                               ($id, 6, 'distributions', 'Distribution de document', 0),
                               ($id, 7, 'DM', 'Devoir maison', 2)",$mysqli);
          // On ajoute la matière uniquement aux utilisateurs qui les ont déjà toutes
          requete('utilisateurs',"UPDATE utilisateurs SET matieres = CONCAT(matieres,',',$id) WHERE LENGTH(matieres) - LENGTH( REPLACE(matieres,',','') ) = $n",$mysqli);
          $message = $_SESSION['message'] = '{"etat":"ok","message":"Matière ajoutée"}';
        }
        else
          $message = '{"etat":"nok","message":"La matière n\'a pas pu être ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      }
    }
    break;

///////////////////////////////////
// Modification des utilisateurs //
///////////////////////////////////
  case 'utilisateurs':

    // Modification du réglage "demandes de création de compte interdite"
    // Les demandes sont interdites si un utilisateur se trouve sans mdp
    if ( isset($_REQUEST['creation']) )  {
      // Récupération du réglage "création impossible"
      $resultat = $mysqli->query('SELECT id FROM utilisateurs WHERE LENGTH(mdp) = 0');
      if ( $creationinterdite = $resultat->num_rows )
        $resultat->free();
      if ( $creationinterdite != isset($_REQUEST['autoriser']) )
        $message = ( $creationinterdite ) ? '{"etat":"ok","message":"Les demandes de création de compte sont déjà interdites."}' : '{"etat":"ok","message":"Les demandes de création de compte sont déjà autorisées."}';
      elseif ( $creationinterdite )
        $message = ( requete('utilisateurs','DELETE FROM utilisateurs WHERE !LENGTH(mdp)',$mysqli) ) ? '{"etat":"ok","message":"Demandes de création de compte désormais autorisées"}' : '{"etat":"nok","message":"Pas de modification. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      else
        $message = ( requete('utilisateurs','INSERT INTO utilisateurs SET mdp = ""',$mysqli) ) ? '{"etat":"ok","message":"Demandes de création de compte désormais interdites"}' : '{"etat":"nok","message":"Pas de modification. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
    }

    // Modifications de tous les utilisateurs : suppression, modification
    // nom/prénom/mail, association à une matière, validation
    elseif ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
      // Vérification que l'identifiant est valide
      $resultat = $mysqli->query("SELECT IF(LENGTH(nom),CONCAT(prenom,' ',nom),login) AS nom, matieres, login, mail, (LENGTH(mdp)=40) AS valide, autorisation FROM utilisateurs WHERE id = $id");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();

        // Suppression
        if ( isset($_REQUEST['supprime']) )  {
          if ( requete('utilisateurs',"DELETE FROM utilisateurs WHERE id = $id",$mysqli)
             && requete('groupes',"UPDATE groupes SET eleves = TRIM(BOTH ',' FROM REPLACE(CONCAT(',',eleves,','),',$id,',',')) WHERE FIND_IN_SET($id,eleves)",$mysqli) )
            $message = $_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"${r['nom']} supprimé\"}";
          else
            $message = '{"etat":"nok","message":"La suppression n\'a pas été réalisée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }

        // Cas des comptes validés : modification et association
        elseif ( $r['valide'] )  {

          // Traitement d'une modification unique
          if ( isset($_REQUEST['champ']) && ( $r['autorisation'] > 1 ) && in_array($champ = $_REQUEST['champ'],array('nom','prenom','mail')) && isset($_REQUEST['val']) && strlen($val = trim($_REQUEST['val'])) )  {
            if ( ( $champ == 'nom' ) || ( $champ == 'prenom' ) )  {
              $val = ucfirst($mysqli->real_escape_string($val));
              $message = ( requete('utilisateurs',"UPDATE utilisateurs SET $champ = '$val' WHERE id = $id",$mysqli) ) ? '{"etat":"ok","message":"'.ucfirst($champ)." de ${r['nom']} modifié\"}" : "{\"etat\":\"nok\",\"message\":\"La modification du $champ de ${r['nom']} n'a pas pu être effectuée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}';
            }
            else  {
              if ( !filter_var($val,FILTER_VALIDATE_EMAIL) )
                $message = '{"etat":"nok","message":"Adresse mail non valide"}';
              else  {
                // Mail : vérification qu'il n'existe pas déjà
                $resultat = $mysqli->query("SELECT GROUP_CONCAT(mail) AS mails FROM utilisateurs WHERE id != $id AND LENGTH(mail)");
                $s = $resultat->fetch_assoc();
                $resultat->free();
                if ( in_array($mail = strtolower($mysqli->real_escape_string($val)),explode(',',$s['mails'])) )
                  $message = '{"etat":"nok","message":"Adresse mail déjà prise"}';
                elseif ( requete('utilisateurs',"UPDATE utilisateurs SET mail = '$mail' WHERE id = $id",$mysqli) )  {
                  $message = "{\"etat\":\"ok\",\"message\":\"Adresse mail de ${r['nom']} modifiée (utilisateur prévenu par mail)\"}";
                  // Récupération de l'adresse mail du professeur connecté
                  $resultat = $mysqli->query("SELECT mail FROM utilisateurs WHERE id = ${_SESSION['id']}");
                  $s = $resultat->fetch_row();
                  $resultat->free();
                  if ( !isset($mailadmin) )
                    $mailadmin = 'admin@cahier-de-prepa.fr';
                  $returnpath = ( strlen($s[0]) ) ? $s[0] : $mailadmin;
                  mail($mail,'=?UTF-8?B?'.base64_encode('[Cahier de Prépa] Changement d\'adresse mail').'?=',
'Bonjour

L\'équipe pédagogique en charge du Cahier de Prépa <http'.($https?'s':'')."://$site> vient de modifier l'adresse électronique correspondant à l'identifiant ${r['login']}. Elle y a mis l'adresse à laquelle vous recevez ce courrier.

S'il s'agit d'une erreur, merci de contacter au plus vite l'administrateur du système Cahier de Prépa à l'adresse <contact@cahier-de-prepa.fr>.

Cordialement,
-- 
Cahier de Prépa
",'From: =?UTF-8?B?'.base64_encode('Cahier de Prépa')."?= <$mailadmin>\r\nContent-type: text/plain; charset=UTF-8","-f$returnpath");
                }
              }
            }
          }

          // Modifications des associations aux matières (depuis matieres.php)
          elseif ( isset($_REQUEST['matiere']) && ctype_digit($matiere = $_REQUEST['matiere']) )  {
            // Vérification que l'identifiant est valide
            $resultat = $mysqli->query("SELECT nom FROM matieres WHERE id = $matiere");
            if ( !$resultat->num_rows )  {
              $mysqli->close();
              exit('{"etat":"nok","message":"Identifiant de matière non valide"}');
            }
            $m = $resultat->fetch_assoc();
            $resultat->free();
            // Si une seule matière : modifications impossibles
            $resultat = $mysqli->query('SELECT COUNT(*) FROM matieres');
            $s = $resultat->fetch_row();
            if ( $s[0] == 1 )  {
              $mysqli->close();
              exit('{"etat":"nok","message":"Tout compte doit être associé à au moins une matière."}');
            }
            $resultat->free();
            // Utilisateur désormais non associé
            if ( $_REQUEST['ok'] == 0 )  {
              if ( !strpos($r['matieres'],',',2) )
                $message = '{"etat":"nok","message":"Tout compte doit être associé à au moins une matière."}';
              elseif ( in_array($matiere,explode(',',$r['matieres'])) )
                $message = ( requete('utilisateurs',"UPDATE utilisateurs SET matieres = TRIM(TRAILING ',' FROM REPLACE(CONCAT(matieres,','),',$matiere,',',')) WHERE id = $id",$mysqli)
                ) ? "{\"etat\":\"ok\",\"message\":\"${r['nom']} n'est plus en ${m['nom']}\"}" : '{"etat":"nok","message":"La modification n\'a pas été réalisée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
              else
                $messsage = "{\"etat\":\"ok\",\"message\":\"${r['nom']} n'était déjà plus en ${m['nom']}\"}";
            }
            // Utilisateur désormais associé
            elseif ( $_REQUEST['ok'] == 1 )  {
              if ( !in_array($matiere,explode(',',$r['matieres'])) )
                $message = ( requete('utilisateurs',"UPDATE utilisateurs SET matieres = CONCAT(matieres,',',$matiere) WHERE id = $id",$mysqli)
                ) ? "{\"etat\":\"ok\",\"message\":\"${r['nom']} est en ${m['nom']}\"}" : '{"etat":"nok","message":"La modification n\'a pas été réalisée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
              else
                $messsage = "{\"etat\":\"ok\",\"message\":\"${r['nom']} était déjà en ${m['nom']}\"}";
            }
            // Mise à jour de $_SESSION['matieres'] si besoin
            if ( $id == $_SESSION['id'] )  {
              $resultat = $mysqli->query("SELECT matieres FROM utilisateurs WHERE id = $id");
              $r = $resultat->fetch_assoc();
              $resultat->free();
              $_SESSION['matieres'] = $r['matieres'];
            }
          }
        }

        // Cas des utilisateurs en attente de validation
        else  {
          if ( requete('utilisateurs',"UPDATE utilisateurs SET mail = SUBSTR(mail,2), mdp = SUBSTR(mdp,2) WHERE id = $id",$mysqli) )  {
            $message = $_SESSION['message'] = '{"etat":"ok","message":"Utilisateur ajouté"}';
            if ( !isset($mailadmin) )
              $mailadmin = 'admin@cahier-de-prepa.fr';
            mail(substr($r['mail'],1),'=?UTF-8?B?'.base64_encode('[Cahier de Prépa] Compte validé').'?=',
'Bonjour

Vous avez rempli une demande de création de compte sur le Cahier de Prépa <http'.($https?'s':'')."://$site>, correspondant à l'identifiant ${r['login']}.

Cette demande vient de recevoir une réponse favorable de la part de l'équipe pédagogique en charge du site. Vous pouvez donc désormais vous connecter avec votre identifiant et votre mot de passe.

Bonne navigation sur Cahier de Prépa.

Cordialement,
-- 
Cahier de Prépa
",'From: =?UTF-8?B?'.base64_encode('Cahier de Prépa')."?= <$mailadmin>\r\nContent-type: text/plain; charset=UTF-8","-f$mailadmin");
          }
          else
            $message = '{"etat":"nok","message":"La validation du compte n\'a pas été réalisée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }

    // Ajout de nouveaux utilisateurs
    elseif ( isset($_REQUEST['utilisateurs']) && isset($_REQUEST['autorisation']) && in_array($autorisation = $_REQUEST['autorisation'],array(1,2,3,4)) && isset($_REQUEST['matiere']) )  {
      $utilisateurs = explode("\n",trim($_REQUEST['utilisateurs']));
      // Récupération des identifiants
      $resultat = $mysqli->query('SELECT GROUP_CONCAT(login) FROM utilisateurs');
      $r = $resultat->fetch_row();
      $resultat->free();
      $logins = explode(',',$r[0]);
      // Vérification de la matière
      $resultat = $mysqli->query('SELECT GROUP_CONCAT(id) AS matieres FROM matieres');
      $r = $resultat->fetch_row();
      $resultat->free();
      $matiere = ( isset($_REQUEST['matiere']) && in_array($_REQUEST['matiere'],explode(',',$r[0])) ) ? "0,${_REQUEST['matiere']}" : "0,${r[0]}";
      // $m: pour le message; $n: nb de comptes ajoutés; $i: compteur de ligne
      $m = '';
      $n = $i = 0;
      // Comptes invités : enregistrement immédiat
      if ( $autorisation == 1 )
        foreach ( $utilisateurs as $utilisateur)  {
          $u = array_map('trim',explode(',',$utilisateur));
          $i = $i+1;
          if ( ( count($u) != 2 ) || !strlen($u[0]) || !strlen($u[1]) )
            $m .= "<br>Ligne $i : mauvais paramètres";
          elseif ( in_array($login = mb_strtolower(str_replace(' ','_',$u[0]),'UTF-8'),$logins) )
            $m .= "<br>Ligne $i : identifiant déjà existant";
          else  {
            $newmdp = sha1($u[1]);
            if ( requete('utilisateurs',"INSERT INTO utilisateurs SET login = '$login', mdp = '$newmdp', autorisation = 1, matieres = '$matiere', timeout=900",$mysqli) )  {
              $m .= "<br>Ligne $i : ok (identifiant $login)";
              $n = $n+1;
            }
            else
              $m .= "<br>Ligne $i : erreur MySQL n°".$mysqli->errno.' «'.$mysqli->error.'»';
          }
        }
      // Comptes élèves, colleurs ou professeurs : mot de passe fourni ou invitation par mail
      else  {
        // Récupération des adresses mails
        $resultat = $mysqli->query('SELECT GROUP_CONCAT(mail) FROM utilisateurs WHERE LENGTH(mail)');
        $r = $resultat->fetch_row();
        $resultat->free();
        foreach ( $utilisateurs as $utilisateur)  {
          if ( !strlen(trim($utilisateur)) )
            continue;
          // Deux séparateurs possibles : ',' => nom-prenom-mail, ';' => nom-prenom-mdp
          $sep = ( strpos($utilisateur.',',',') < strpos($utilisateur.';',';') ) ? ',' : ';';
          $u = array_map('trim',explode($sep,$utilisateur));
          $i = $i+1;
          $mail = '';
          if ( ( count($u) != 3 ) || !strlen($u[0].$u[1]) || !strlen($u[2]) )
            $m .= "<br>Ligne $i : mauvais paramètres";
          elseif ( ( $sep == ',' ) && in_array($mail = strtolower($u[2]),explode(',',$r[0])) )
            $m .= "<br>Ligne $i : mail déjà existant";
          elseif ( ( $sep == ',' ) && !filter_var($mail,FILTER_VALIDATE_EMAIL) )
            $m .= "<br>Ligne $i : mail non valide";
          else  {
            // Nettoyage des données envoyées
            $nom = mb_convert_case(strip_tags($mysqli->real_escape_string($u[0])),MB_CASE_TITLE,'UTF-8');
            $prenom = mb_convert_case(strip_tags($mysqli->real_escape_string($u[1])),MB_CASE_TITLE,'UTF-8');
            $login = mb_strtolower(mb_substr($prenom,0,1,'UTF-8').str_replace(' ','_',$nom),'UTF-8');
            if ( in_array($login,$logins) )
              $m .= "<br>Ligne $i : identifiant déjà existant";
            else  {
              $newmdp = ( $mail ) ? '*' : sha1($u[2]);
              $mailexp = ( $autorisation > 2 ) ? "$prenom $nom" : '';
              $mailcopy = ( $autorisation > 2 ) ? 1 : 0;
              if ( requete('utilisateurs',"INSERT INTO utilisateurs SET login = '$login', prenom = '$prenom', nom = '$nom', mail = '$mail',
                         mdp = '$newmdp', autorisation = $autorisation, matieres = '$matiere', timeout = 900, mailexp = '$mailexp', mailcopy = 1",$mysqli) )  {
                $m .= "<br>Ligne $i : ok ($prenom $nom, identifiant $login)";
                $n = $n+1;
                if ( $mail )  {
                  $lien = ( $https ? 'https' : 'http' )."://$site/connexion?reponseinvitation&mail=$mail&p=".sha1($site.$mdp.$mail);
                  // Récupération de l'adresse mail du professeur connecté
                  $resultat = $mysqli->query("SELECT mail FROM utilisateurs WHERE id = ${_SESSION['id']}");
                  $s = $resultat->fetch_row();
                  $resultat->free();
                  if ( !isset($mailadmin) )
                    $mailadmin = 'admin@cahier-de-prepa.fr';
                  $returnpath = ( strlen($s[0]) ) ? $s[0] : $mailadmin;
                  mail($mail,'=?UTF-8?B?'.base64_encode('[Cahier de Prépa] Invitation').'?=',
'Bonjour

L\'équipe pédagogique en charge du Cahier de Prépa <http'.($https?'s':'')."://$site> vous invite à les rejoindre.

S'il s'agit d'une erreur, merci d'ignorer simplement ce mail.

Sinon, veuillez cliquer ci-dessous pour vous rendre à la page qui vous permettra d'entrer un mot de passe :
   $lien

Bonne navigation sur Cahier de Prépa.

Cordialement,
-- 
Cahier de Prépa
",'From: =?UTF-8?B?'.base64_encode('Cahier de Prépa')."?= <$mailadmin>\r\nContent-type: text/plain; charset=UTF-8","-f$returnpath");
                }
              }
              else
                $m .= "<br>Ligne $i : erreur MySQL n°".$mysqli->errno.' «'.$mysqli->error.'»';
            }
          }
        }
      }
      // Fabrication du message
      $nouveaucompte = ( $n > 1 ) ? 'nouveaux comptes' : 'nouveau compte';
      if ( $e = $i-$n )
        $message = "{\"etat\":\"nok\",\"message\":\"$n $nouveaucompte et $e erreur".(($e>1)?'s':'')."$m\"}";
      else
        $message = $_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"$n $nouveaucompte$m\"}";
    }
    break;

//////////////////////////////////
// Modification des répertoires //
//////////////////////////////////
  case 'reps':
  
    // Vérification que l'identifiant est valide
    if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
      $resultat = $mysqli->query("SELECT parent, nom, menu, protection, matiere, nbrep+nbdoc AS nb FROM reps WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();

        // Traitement d'une modification unique (nom)
        if ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'nom' ) )  {
          if ( !$r['parent'] )
            $message = '{"etat":"nok","message":"Le nom des répertoires racine des matières ne sont pas modifiables."}';
          elseif ( !strlen($valeur = trim($mysqli->real_escape_string($_REQUEST['val'])) ) )
            $message = '{"etat":"nok","message":"Le répertoire n\'a pas pu être modifié. Nom non vide nécessaire."}';
          elseif ( requete('reps',"UPDATE reps SET nom = '$valeur' WHERE id = $id",$mysqli) )  {
            $message = '{"etat":"ok","message":"Répertoire modifié"}';
          }
          else
            $message = '{"etat":"nok","message":"Le répertoire n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }
          
        // Traitement d'une modification globale
        elseif ( isset($_REQUEST['protection']) )  {
          $requete = $message = array();
          $etat = 'ok';
          // Modification du nom, de l'affichage dans le menu uniquement si pas à la racine
          if ( $r['parent'] && isset($_REQUEST['nom']) )  {
            if ( strlen($nom = trim($mysqli->real_escape_string($_REQUEST['nom'])) ) && ( $nom != $r['nom'] ) )
              $requete[] = "nom = '$nom'";
            $menu = isset($_REQUEST['menu']) ? 1 : 0;
            if ( $menu != $r['menu'] )
              $requete[] = "menu = $menu";
          }
          $protection = ( in_array($_REQUEST['protection'],array(0,1,2,3,4,5)) ) ? $_REQUEST['protection'] : 0;
          if ( $protection != $r['protection'] )
            $requete[] = "protection = $protection";
          if ( $requete )  {
            if ( requete('reps','UPDATE reps SET '.implode(', ',$requete)." WHERE id = $id",$mysqli) ) 
              $message[] = 'Répertoire modifié ';
            else  {
              $message[] = 'Le répertoire n\'a pas pu être modifié. (Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»)';
              $etat = 'nok';
            }
          }
          // Déplacement du répertoire si $_REQUEST['parent'] non nul et si pas à la racine
          if ( ( $r['parent'] ) && isset($_REQUEST['parent']) && ctype_digit($parent = $_REQUEST['parent']) && !in_array($parent,array(0,$id,$r['parent'])) )  {
            // Vérification du répertoire parent
            $resultat = $mysqli->query("SELECT parents, matiere FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}') AND NOT FIND_IN_SET($id,parents)");
            if ( $resultat->num_rows)  {
              $s = $resultat->fetch_assoc();
              $resultat->free();
              $mat = $s['matiere'];
              $parents = "${s['parents']},$parent";
              if ( requete('reps',"UPDATE reps SET matiere = $mat, parent = $parent, parents = '$parents' WHERE id = $id",$mysqli)
                && requete('reps',"UPDATE reps SET matiere = $mat, parents = '$parents,$id' WHERE parent = $id",$mysqli)
                && requete('docs',"UPDATE docs SET matiere = $mat, parents = '$parents,$id' WHERE parent = $id",$mysqli) )
                $message[] = 'Répertoire déplacé';
              else  {
                $message[] = 'Le répertoire n\'a pas pu être déplacé. (Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»)';
                $etat = 'nok';
              }
            }
            else  {
              $message[] = 'Répertoire non déplacé (identifiant de répertoire parent non valide)';
              $etat = 'nok';
            }
          }
          // Propagation des droits d'accès aux sous-répertoires et documents
          if ( isset($_REQUEST['propagation']) && ( $r['nb'] ) )  {
            if ( requete('reps',"UPDATE reps SET protection = $protection WHERE FIND_IN_SET($id,parents)",$mysqli)
              && requete('docs',"UPDATE docs SET protection = $protection WHERE FIND_IN_SET($id,parents)",$mysqli) ) 
              $message[] = 'Réglage d\'accès propagé';
            else  {
              $message[] = 'Le réglage d\'accès n\a pas pu être propagé. (Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»)';
              $etat = 'nok';
            }
          }
          // Reconstruction du message
          $message = $_SESSION['message'] = ( $message ) ? "{\"etat\":\"$etat\",\"message\":\"".implode(', ',$message).'"}' : '';
        }

        // Suppression
        elseif ( isset($_REQUEST['supprime']) )  {
          if ( !$r['parent'] )
            $message = '{"etat":"nok","message":"Les répertoires racine des matières ne sont pas supprimables."}';
          elseif ( requete('reps',"DELETE FROM reps WHERE id = $id OR FIND_IN_SET($id,parents)",$mysqli) )  {
            // Suppression physique
            $resultat = $mysqli->query("SELECT lien FROM docs WHERE FIND_IN_SET($id,parents)");
            if ( $resultat->num_rows )  {
              while ( $r = $resultat->fetch_row() )
                exec("rm -rf documents/${r[0]}");
              $resultat->free();
              requete('docs',"DELETE FROM docs WHERE FIND_IN_SET($id,parents)",$mysqli);
            }
            $message = '{"etat":"ok","message":"Répertoire supprimé"}';
          }
          else
            $message = '{"etat":"nok","message":"Le répertoire n\'a pas pu être supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }
    
    // Nouveau répertoire
    elseif ( isset($_REQUEST['nom']) && isset($_REQUEST['protection']) && isset($_REQUEST['parent']) && strlen($nom = trim($mysqli->real_escape_string($_REQUEST['nom']))) && ctype_digit($parent=$_REQUEST['parent']) )  {
      $resultat = $mysqli->query("SELECT parents, matiere FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows)  {
        $s = $resultat->fetch_assoc();
        $resultat->free();
        $protection = ( in_array($_REQUEST['protection'],array(0,1,2,3,4,5)) ) ? $_REQUEST['protection'] : 0;
        $menu = isset($_REQUEST['menu']) ? 1 : 0;
        if ( requete('reps',"INSERT INTO reps SET parent = $parent, parents = '${s['parents']},$parent', nom = '$nom', matiere = ${s['matiere']},
                             nbrep = 0, nbrep_v = 0, nbdoc = 0, nbdoc_v = 0, protection = $protection, menu = $menu",$mysqli) )
          $message = $_SESSION['message'] = '{"etat":"ok","message":"Répertoire ajouté"}';
        else
          $message = '{"etat":"nok","message":"Le répertoire n\'a pas pu être ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      }
      else
        $message = '{"etat":"nok","message":"Identifiant du répertoire parent non valide"}';
    }

    // Mise à jour des champs nbrep/nbdoc dans la table 'reps'
    $mysqli->query('UPDATE reps AS r SET 
      nbrep = (SELECT COUNT(id) FROM (SELECT * FROM reps) AS r1 WHERE r.id = r1.parent),
      nbrep_v = (SELECT COUNT(id) FROM (SELECT * FROM reps WHERE reps.protection<5) AS r2 WHERE r.id = r2.parent),
      nbdoc = (SELECT COUNT(id) FROM docs AS d WHERE r.id = d.parent),
      nbdoc_v = (SELECT COUNT(id) FROM docs AS d WHERE r.id = d.parent AND d.protection<5)');
    $mysqli->query('ALTER TABLE reps ORDER BY parents,nom');
    // Mise à jour des champs 'docs' dans la table 'matieres' (pour le menu)
    $mysqli->query('UPDATE matieres SET docs = (SELECT IF(SUM(nbdoc_v),1-(protection=5 AND parent=0),0) FROM reps WHERE matiere = matieres.id)');
    
    break;

////////////////////////////////
// Modification des documents //
////////////////////////////////
  case 'docs':

    // Vérification que l'identifiant est valide
    if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
      $resultat = $mysqli->query("SELECT nom, protection, ext, lien, parent FROM docs WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();

        // Traitement d'une modification unique (nom)
        if ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'nom' ) )  {
          if ( !strlen( $valeur = trim($_REQUEST['val']) ) )
            $message = '{"etat":"nok","message":"Le document n\'a pas pu être modifié. Nom non vide nécessaire."}';
          elseif ( $valeur != $r['nom'] )  {
            setlocale(LC_CTYPE, "fr_FR.UTF-8");
            $nom = substr((str_replace(array($r['ext'],'\\','/'),array('','-','-'),$valeur)),0,100);
            // real_escape_string seulement pour la requête SQL
            if ( requete('docs','UPDATE docs SET nom = \''.$mysqli->real_escape_string($nom).'\', nom_nat = \''.zpad($mysqli->real_escape_string($nom))."' WHERE id = $id",$mysqli) )  {
              exec('mv documents/'.escapeshellarg("${r['lien']}/${r['nom']}${r['ext']}").' documents/'.escapeshellarg("${r['lien']}/$nom${r['ext']}"));
              $message = '{"etat":"ok","message":"Document modifié"}';
              $mysqli->query('ALTER TABLE docs ORDER BY parents,nom_nat');
            }
            else
              $message = '{"etat":"nok","message":"Le document n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
          }
        }

        // Traitement d'une modification globale
        elseif ( isset($_REQUEST['nom']) && isset($_REQUEST['parent']) && isset($_REQUEST['protection']) && strlen($nom = trim($_REQUEST['nom'])) )  {
          $requete = $message = array();
          $etat = 'ok';
          // Modification du nom et de la protection
          setlocale(LC_CTYPE, "fr_FR.UTF-8");
          $nom = substr(basename(str_replace(array($r['ext'],'\\'),array('','/'),$nom)),0,100);
          $protection = ( in_array($_REQUEST['protection'],array(0,1,2,3,4,5)) ) ? $_REQUEST['protection'] : 0;
          if ( $nom != $r['nom'] )  {
            // real_escape_string seulement pour la requête SQL
            if ( requete('docs','UPDATE docs SET nom = \''.$mysqli->real_escape_string($nom).'\', nom_nat = \''.zpad($mysqli->real_escape_string($nom))."', protection = $protection WHERE id = $id",$mysqli) )  {
              exec('mv documents/'.escapeshellarg("${r['lien']}/${r['nom']}${r['ext']}").' documents/'.escapeshellarg("${r['lien']}/$nom${r['ext']}"));
              $message[] = 'Document modifié';
            }
            else  {
              $message[] = 'Le document n\'a pas pu être modifié. (Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»)';
              $etat = 'nok';
            }
          }
          elseif ( $protection != $r['protection'] )  {
            if ( requete('docs',"UPDATE docs SET protection = $protection WHERE id = $id",$mysqli) )
              $message[] = 'Document modifié';
            else  {
              $message[] = 'Le document n\'a pas pu être modifié. (Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»)';
              $etat = 'nok';
            }
          }

          // Déplacement dans un autre répertoire
          if ( ctype_digit($parent = $_REQUEST['parent']) && $parent && ( $parent != $r['parent'] ) )  {
            // Vérification du répertoire parent
            $resultat = $mysqli->query("SELECT parents, matiere FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
            if ( $resultat->num_rows )  {
              $s = $resultat->fetch_assoc();
              $resultat->free();
              if ( requete('docs',"UPDATE docs SET parent = '$parent', parents = '${s['parents']},$parent', matiere = ${s['matiere']} WHERE id = $id",$mysqli) )
                $message[] = 'Document déplacé';
              else  {
                $message[] = 'Le document n\'a pas pu être déplacé. (Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»)';
                $etat = 'nok';
              }
            }
            else  {
              $message[] = 'Document non déplacé (identifiant de répertoire parent non valide)';
              $etat = 'nok';
            }
          }
                    
          // Si modification(s), on met à jour les informations récentes éventuelles
          if ( $message && ( $etat = 'ok' ) )  {
            if ( $protection < 5 )  {
              // Fabrication des données pour les informations récentes
              $resultat = $mysqli->query("SELECT GROUP_CONCAT( reps.nom ORDER BY FIND_IN_SET(reps.id,docs.parents) SEPARATOR '/' ) AS path, docs.matiere, docs.nom, docs.protection
                                          FROM docs LEFT JOIN reps ON FIND_IN_SET(reps.id,docs.parents) WHERE docs.id = $id");
              $s = $resultat->fetch_assoc();
              $resultat->free();
              $path = $mysqli->real_escape_string("${s['path']}/${s['nom']}");
              // Liste des icônes pour affichage
              $icones = array(
                '.pdf' => '-pdf',
                '.doc' => '-doc', '.odt' => '-doc', '.docx' => '-doc',
                '.xls' => '-xls', '.ods' => '-xls', '.xlsx' => '-xls',
                '.ppt' => '-ppt', '.odp' => '-ppt', '.pptx' => '-ppt',
                '.jpg' => '-jpg', '.jpeg' => '-jpg', '.png' => '-jpg', '.gif' => '-jpg', '.svg' => '-jpg', '.tif' => '-jpg', '.tiff' => '-jpg', '.bmp' => '-jpg', '.ps' => '-jpg', '.eps' => '-jpg',
                '.mp3' => '-mp3', '.ogg' => '-mp3', '.oga' => '-mp3', '.wma' => '-mp3', '.wav' => '-mp3', '.ra' => '-mp3', '.rm' => '-mp3',
                '.mp4' => '-mp4', '.avi' => '-mp4', '.mpeg' => '-mp4', '.mpg' => '-mp4', '.wmv' => '-mp4', '.mp4' => '-mp4', '.ogv' => '-mp4', '.qt' => '-mp4', '.mov' => '-mp4', '.mkv' => '-mp4', '.flv' => '-mp4',
                '.zip' => '-zip', '.rar' => '-zip', '.7z' => '-zip',
                '.py' => '-pyt', '.exe' => '-pyt', '.sh' => '-pyt', '.ml' => '-pyt', '.mw' => '-pyt',
                '.txt' => '-txt', '.rtf' => '-txt', '' => '-txt'
              );
              $icone = ( isset($icones[$ext=strtolower($r['ext'])]) ) ? $icones[$ext] : '-txt';
              recent($mysqli,3,$id,array('titre'=>"<span class=\"icon-doc$icone\"></span> $path", 'lien'=>"download?id=$id", 'texte'=>"<p>Modification du document&nbsp;: <a href=\"download?id=$id\">$path</a></p>", 'matiere'=>$s['matiere'], 'protection'=>$s['protection']));
            }
            // Si $protection = 5, on cherche à supprimer.
            else
              recent($mysqli,3,$id);
          }

          // Mise à jour d'un document
          if ( isset($_FILES['fichier']['tmp_name']) && is_uploaded_file($_FILES['fichier']['tmp_name']) )  {
            // Changement d'extension suspect donc interdit
            $ext = ( strpos($_FILES['fichier']['name'],'.') ) ? strrchr($_FILES['fichier']['name'],'.') : '';
            if ( $ext != $r['ext'] )  {
              $message[] = 'Document non mis à jour (extension du fichier envoyé non conforme)';
              $etat = 'nok';
            }
            // Déplacement du document uploadé au bon endroit
            elseif ( move_uploaded_file($_FILES['fichier']['tmp_name'],"documents/${r['lien']}/${r['nom']}${r['ext']}") )  {
              // Gestion de la taille
              $taille = intval($_FILES['fichier']['size']/1024);
              $taille = ( $taille < 1024 ) ? "$taille&nbsp;ko" : intval($taille/1024).'&nbsp;Mo';
              // Modifications dans la base de données
              requete('docs',"UPDATE docs SET upload = DATE(NOW()), taille = '$taille' WHERE id = $id",$mysqli);
              // Information récente si document visible
              if ( $r['protection'] < 5 )  {
                $resultat = $mysqli->query("SELECT GROUP_CONCAT( reps.nom ORDER BY FIND_IN_SET(reps.id,docs.parents) SEPARATOR '/' ) AS path, docs.matiere, docs.nom, docs.protection
                                            FROM docs LEFT JOIN reps ON FIND_IN_SET(reps.id,docs.parents) WHERE docs.id = $id");
                $s = $resultat->fetch_assoc();
                $resultat->free();
                $path = $mysqli->real_escape_string("${s['path']}/${s['nom']}");
                // Liste des icônes pour affichage
                $icones = array(
                  '.pdf' => '-pdf',
                  '.doc' => '-doc', '.odt' => '-doc', '.docx' => '-doc',
                  '.xls' => '-xls', '.ods' => '-xls', '.xlsx' => '-xls',
                  '.ppt' => '-ppt', '.odp' => '-ppt', '.pptx' => '-ppt',
                  '.jpg' => '-jpg', '.jpeg' => '-jpg', '.png' => '-jpg', '.gif' => '-jpg', '.svg' => '-jpg', '.tif' => '-jpg', '.tiff' => '-jpg', '.bmp' => '-jpg', '.ps' => '-jpg', '.eps' => '-jpg',
                  '.mp3' => '-mp3', '.ogg' => '-mp3', '.oga' => '-mp3', '.wma' => '-mp3', '.wav' => '-mp3', '.ra' => '-mp3', '.rm' => '-mp3',
                  '.mp4' => '-mp4', '.avi' => '-mp4', '.mpeg' => '-mp4', '.mpg' => '-mp4', '.wmv' => '-mp4', '.mp4' => '-mp4', '.ogv' => '-mp4', '.qt' => '-mp4', '.mov' => '-mp4', '.mkv' => '-mp4', '.flv' => '-mp4',
                  '.zip' => '-zip', '.rar' => '-zip', '.7z' => '-zip',
                  '.py' => '-pyt', '.exe' => '-pyt', '.sh' => '-pyt', '.ml' => '-pyt', '.mw' => '-pyt',
                  '.txt' => '-txt', '.rtf' => '-txt', '' => '-txt'
                );
                $icone = ( isset($icones[$ext=strtolower($r['ext'])]) ) ? $icones[$ext] : '-txt';
                recent($mysqli,3,$id,array('titre'=>"<span class=\"icon-doc$icone\"></span> $path", 'lien'=>"download?id=$id", 'texte'=>"<p>Mise à jour du document&nbsp;: <a href=\"download?id=$id\">$path</a></p>", 'matiere'=>$s['matiere'], 'protection'=>$s['protection']));
              }
              $message[] = 'Document mis à jour';
            }
            else  {
              $message[] = 'Document non mis à jour (problème d\'écriture du fichier)';
              $etat = 'nok';
            }
          }
          // Reconstruction du message
          $message = $_SESSION['message'] = ( $message ) ? "{\"etat\":\"$etat\",\"message\":\"".implode(', ',$message).'"}' : '';
        }
        
        // Suppression d'un document
        elseif ( isset($_REQUEST['supprime']) )  {
          if ( requete('docs',"DELETE FROM docs WHERE id = $id",$mysqli) )  {
            // Suppression physique
            exec("rm -rf documents/${r['lien']}");
            $message = '{"etat":"ok","message":"Document supprimé"}';
            recent($mysqli,3,$id);
          }
          else
            $message = '{"etat":"nok","message":"Le document n\'a pas pu être supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
        }
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }
    
    // Nouveau document
    elseif ( isset($_FILES['fichier']['tmp_name']) && is_uploaded_file($_FILES['fichier']['tmp_name']) && isset($_REQUEST['nom']) && isset($_REQUEST['protection']) && isset($_REQUEST['parent']) && ctype_digit($parent = $_REQUEST['parent']) )  {
      // Vérification du répertoire parent
      $resultat = $mysqli->query("SELECT parents, matiere FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
      if ( $resultat->num_rows)  {
        $s = $resultat->fetch_assoc();
        $resultat->free();
        // Vérifications des données envoyées (on fait confiance aux utilisateurs connectés pour ne pas envoyer de scripts malsains)
        $nom = $_FILES['fichier']['name'];
        // $est ne doit pas faire plus de 4 caractères sinon fichier plus accessible
        $ext = ( strpos($nom,'.') ) ? substr(strrchr($nom,'.'),0,4) : '';
        setlocale(LC_CTYPE, "fr_FR.UTF-8");
        $nom = substr(basename(str_replace(array($ext,'\\'),array('','/'), ( strlen($_REQUEST['nom']) ) ? $_REQUEST['nom'] : $nom )),0,100);
        $protection = ( in_array($_REQUEST['protection'],array(0,1,2,3,4,5)) ) ? $_REQUEST['protection'] : 0;
        // Création du répertoire particulier
        $lien = substr(sha1(mt_rand()),0,15);
        while ( is_dir("documents/$lien") )
          $lien = substr(sha1(mt_rand()),0,15);
        mkdir("documents/$lien");
        // Gestion de la taille
        $taille = intval($_FILES['fichier']['size']/1024);
        $taille = ( $taille < 1024 ) ? "$taille&nbsp;ko" : intval($taille/1024).'&nbsp;Mo';
        // Déplacement du document uploadé au bon endroit
        if ( move_uploaded_file($_FILES['fichier']['tmp_name'],"documents/$lien/$nom$ext") )  {
          // Écriture MySQL
          if ( requete('docs',"INSERT INTO docs SET parent = $parent, parents = '${s['parents']},$parent',
                               matiere = ${s['matiere']}, nom = '".$mysqli->real_escape_string($nom).'\', nom_nat = \''.zpad($mysqli->real_escape_string($nom))."', upload = DATE(NOW()),
                               taille = '$taille', lien = '$lien', ext='".$mysqli->real_escape_string($ext)."', protection = $protection",$mysqli) )  {
            $id = $mysqli->insert_id;
            $message = $_SESSION['message'] = '{"etat":"ok","message":"Document ajouté"}';
            // Mise à jour des informations récentes
            if ( $protection < 5 )  {
              $resultat = $mysqli->query("SELECT GROUP_CONCAT( reps.nom ORDER BY FIND_IN_SET(reps.id,docs.parents) SEPARATOR '/' ) AS path, docs.protection, docs.matiere
                                          FROM docs LEFT JOIN reps ON FIND_IN_SET(reps.id,docs.parents) WHERE docs.id = $id");
              $s = $resultat->fetch_assoc();
              $resultat->free();
              $path = $mysqli->real_escape_string("${s['path']}/$nom");
              // Liste des icônes pour affichage
              $icones = array(
                '.pdf' => '-pdf',
                '.doc' => '-doc', '.odt' => '-doc', '.docx' => '-doc',
                '.xls' => '-xls', '.ods' => '-xls', '.xlsx' => '-xls',
                '.ppt' => '-ppt', '.odp' => '-ppt', '.pptx' => '-ppt',
                '.jpg' => '-jpg', '.jpeg' => '-jpg', '.png' => '-jpg', '.gif' => '-jpg', '.svg' => '-jpg', '.tif' => '-jpg', '.tiff' => '-jpg', '.bmp' => '-jpg', '.ps' => '-jpg', '.eps' => '-jpg',
                '.mp3' => '-mp3', '.ogg' => '-mp3', '.oga' => '-mp3', '.wma' => '-mp3', '.wav' => '-mp3', '.ra' => '-mp3', '.rm' => '-mp3',
                '.mp4' => '-mp4', '.avi' => '-mp4', '.mpeg' => '-mp4', '.mpg' => '-mp4', '.wmv' => '-mp4', '.mp4' => '-mp4', '.ogv' => '-mp4', '.qt' => '-mp4', '.mov' => '-mp4', '.mkv' => '-mp4', '.flv' => '-mp4',
                '.zip' => '-zip', '.rar' => '-zip', '.7z' => '-zip',
                '.py' => '-pyt', '.exe' => '-pyt', '.sh' => '-pyt', '.ml' => '-pyt', '.mw' => '-pyt',
                '.txt' => '-txt', '.rtf' => '-txt', '' => '-txt'
              );
              $icone = ( isset($icones[$ext]) ) ? $icones[$ext] : '-txt';
              recent($mysqli,3,$id,array('titre'=>"<span class=\"icon-doc$icone\"></span> $path", 'lien'=>"download?id=$id", 'texte'=>"<p>Nouveau document&nbsp;: <a href=\"download?id=$id\">$path</a></p>", 'matiere'=>$s['matiere'], 'protection'=>$s['protection']));
            }
          }
          else  {
            // Retour en arrière
            exec("rm -rf documents/$lien");
            $message = '{"etat":"nok","message":"Le document n\'a pas pu être ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
          }
        }
        else
          $message = '{"etat":"nok","message":"Le document n\'a pas pu  ajouté (problème d\'écriture du fichier)."}';        
      }
      else
        $message = '{"etat":"nok","message":"Identifiant du répertoire parent non valide"}';
    }

    // Mise à jour des champs nbdoc dans la table 'reps'
    $mysqli->query('UPDATE reps AS r SET 
      nbdoc = (SELECT COUNT(id) FROM docs AS d WHERE r.id = d.parent),
      nbdoc_v = (SELECT COUNT(id) FROM docs AS d WHERE r.id = d.parent AND d.protection<5)');
    $mysqli->query('ALTER TABLE docs ORDER BY parents,nom_nat');
    // Mise à jour des champs 'docs' dans la table 'matieres' (pour le menu)
    $mysqli->query('UPDATE matieres SET docs = (SELECT IF(SUM(nbdoc_v),1-(protection=5 AND parent=0),0) FROM reps WHERE matiere = matieres.id)');
    
    break;

//////////////////////////////
// Modification du planning //
//////////////////////////////
  case 'semaines':

    // Récupérations des donnees envoyées
    $colles = ( isset($_REQUEST['colles']) ) ? $_REQUEST['colles'] : array();
    $vacances = $_REQUEST['vacances'];
    // Comparaison et modification
    $modif = array();
    $resultat = $mysqli->query('SELECT id, colle, vacances, DATE_FORMAT(debut,\'%d/%m/%Y\') AS debut FROM semaines');
    while ( $r = $resultat->fetch_assoc() )  {
      if ( !is_numeric($v = $vacances[$r['id']]) )
        $v = 0;
      $c = ( isset($colles[$r['id']]) && !$v ) ? 1 : 0;
      if ( ( $c != $r['colle'] ) || ( $v != $r['vacances'] ) )  {
        requete('semaines',"UPDATE semaines SET colle = $c, vacances = $v WHERE id = ${r['id']}",$mysqli);
        $modif[] = "semaine du ${r['debut']}";
      }
    }
    // Message à afficher
    if ( $modif )
      $message = '{"etat":"ok","message":"Modifications réalisées ('.implode(',',$modif).')"}';

    break;

///////////////////////////////////////
// Modification des groupes d'élèves //
///////////////////////////////////////
  case 'groupes':

    // Vérification que l'identifiant est valide
    if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
      $resultat = $mysqli->query("SELECT nom, mailnotes, eleves FROM groupes WHERE id = $id");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $resultat->free();

        // Traitement d'une modification unique (nom, mailnotes)
        if ( isset($_REQUEST['champ']) && in_array($champ = $_REQUEST['champ'],array('nom','mailnotes')) )  {
          switch ( $champ )  {
            case 'nom':
              if ( !strlen($valeur = $mysqli->real_escape_string($_REQUEST['val'])) )
                $message = '{"etat":"nok","message":"Groupe non modifié. Nom non vide nécessaire."}';
              elseif ( requete('groupes',"UPDATE groupes SET nom = '$valeur', nom_nat = '".zpad($valeur)."' WHERE id = $id",$mysqli) )  {
                $message = '{"etat":"ok","message":"Groupe modifié"}';
                $mysqli->query('ALTER TABLE groupes ORDER BY nom_nat');
              }
              else
                $message = '{"etat":"nok","message":"Le groupe n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
              break;
            case 'mailnotes':
              $valeur = ( in_array($_REQUEST['val'],array(1,2,3)) ) ? $_REQUEST['val'] : 0;
              $message = ( requete('groupes',"UPDATE groupes SET mailnotes = $valeur WHERE id = $id",$mysqli) ) ? '{"etat":"ok","message":"Groupe modifié"}' : '{"etat":"nok","message":"Le groupe n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
          }
        }

        // Ajout/Suppression d'un élève dans le groupe
        elseif ( isset($_REQUEST['eleve']) && isset($_REQUEST['ok']) )  {
          // Suppression de l'élève dans le groupe
          if ( $_REQUEST['ok'] == 0 )  {
            if ( !strpos($r['eleves'],',') )
              $message = '{"etat":"nok","message":"Groupe non modifié. Un utilisateur au minimum est nécessaire."}';
            elseif( in_array($eleve = $_REQUEST['eleve'],explode(',',$r['eleves'])) )
              $message = ( requete('groupes',"UPDATE groupes SET eleves = TRIM(BOTH ',' FROM REPLACE(CONCAT(',',eleves,','),',$eleve,',',')) WHERE id = $id",$mysqli) ) ? '{"etat":"ok","message":"Groupe modifié"}' : '{"etat":"nok","message":"Le groupe n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
          }
          // Ajout de l'élève dans le groupe
          elseif ( ctype_digit($eleve = $_REQUEST['eleve']) && !in_array($eleve,explode(',',$r['eleves'])) )  {
            // Vérification de l'identifiant
            $resultat = $mysqli->query("SELECT id FROM utilisateurs WHERE id = $eleve AND autorisation = 2 AND LENGTH(mdp)=40");
            if ( $resultat->num_rows )  {
              $resultat->free();
              $message = ( requete('groupes',"UPDATE groupes SET eleves = CONCAT(eleves,',$eleve') WHERE id = $id",$mysqli) ) ? '{"etat":"ok","message":"Groupe modifié"}' : '{"etat":"nok","message":"Le groupe n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
            }
            else
              $message = '{"etat":"nok","message":"Groupe non modifié. Identifiant d\'élève incorrect."}';
          }
        }

        // Suppression
        elseif ( isset($_REQUEST['supprime']) )
          $message = ( requete('groupes',"DELETE FROM groupes WHERE id = $id",$mysqli) ) ? '{"etat":"ok","message":"Groupe supprimé"}' : '{"etat":"nok","message":"La suppression n\'a pas été réalisée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      }
      else
        $message = '{"etat":"nok","message":"Identifiant non valide"}';
    }

    // Nouveau groupe
    elseif ( isset($_REQUEST['nom']) && isset($_REQUEST['mailnotes']) && isset($_REQUEST['eleves']) && in_array($mailnotes = $_REQUEST['mailnotes'],array(1,2,3)) )  {
      if ( !strlen($nom = $mysqli->real_escape_string($_REQUEST['nom'])) )
        $message = '{"etat":"nok","message":"Groupe non ajouté. Nom non vide nécessaire."}';
      else  {
        $resultat = $mysqli->query('SELECT GROUP_CONCAT(id) FROM utilisateurs WHERE autorisation = 2 AND LENGTH(mdp)=40');
        $r = $resultat->fetch_row();
        $resultat->free();
        if ( !strlen($eleves = implode(',',array_intersect(explode(',',$r[0]),explode(',',$_REQUEST['eleves'])))) )
          $message = '{"etat":"nok","message":"Groupe non ajouté. Un ou plusieurs élèves sont nécessaires."}';
        elseif ( requete('groupes',"INSERT INTO groupes SET nom = '$nom', nom_nat = '".zpad($nom)."', mailnotes = $mailnotes, eleves = '$eleves'",$mysqli) )  {
          $message = $_SESSION['message'] = '{"etat":"ok","message":"Groupe ajouté"}';
          $mysqli->query('ALTER TABLE groupes ORDER BY nom_nat');
        }
        else
          $message = '{"etat":"nok","message":"Le groupe n\'a pas pu être ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}';
      }
    }
    break;
}
}

$mysqli->close();
if ( !strlen($message) )
  $message = '{"etat":"nok","message":"Aucune action effectuée"}';
exit($message);
?>
