<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

// HTTPS obligatoire dès le début si $https est true
if ( $https && !isset($_SERVER['HTTPS']) )  {
  header("Location: https://{$_SERVER['HTTP_HOST']}{$_SERVER['REQUEST_URI']}");
  exit();
}

////////////////////////////////////////////////////////////////////////////////
//////////////////////////// Gestion de la session /////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// Connexion et déconnexion sont gérées dans ajax.php
session_name(md5($site));
session_set_cookie_params(0,strchr($site,'/').'/',str_replace(strchr($site,'/'),'',$site));
session_start();
$autorisation = 0;
$message = '';
// Gestion des utilisateurs connectés
if ( isset($_SESSION[md5("$site")]) )  {
  // Déconnexion automatique
  if ( ( $_SESSION['time'] < time() ) || ( $_SESSION['client'] != $_SERVER['HTTP_USER_AGENT'] ) || ( $_SESSION['ip'] != $_SERVER['REMOTE_ADDR'] ) )  {
    $message = 'Vous devez vous connecter à nouveau, suite à une longue durée d\'inactivité.';
    // Suppression du cookie et des données de session
    $_SESSION = array();
    setcookie(session_name(),'',time()-3600);
    session_regenerate_id(true);
  }
  // Tout est ok : session valide pendant timeout
  else  {
    $_SESSION['time'] = time()+$_SESSION['timeout']+14400*!$_SESSION['timeout'];
    $autorisation = $_SESSION['autorisation'];
  }
}

////////////////////////////////////////////////////////////////////////////////
/////////////////// Fonctions utilisées dans Cahier de Prépa ///////////////////
////////////////////////////////////////////////////////////////////////////////

/////////////
/// MySQL ///
/////////////

// Connexion à la base MySQL
function connectsql($ecriture=false)  {
  $mysqli = new mysqli($GLOBALS['serveur'],( $ecriture ) ? $GLOBALS['base'].'-adm' : $GLOBALS['base'], $GLOBALS['mdp'], $GLOBALS['base']);
  $mysqli->set_charset('utf8');
  return $mysqli;
}

// Fonction d'envoi de requêtes MySQL et d'enregistrement
//  * sauvegarde une fois par mois la table complète
//  * enregistre la requête
//  * exécute la requête
//  * renvoie le résultat de l'exécution
function requete($table,$requete,$mysqli)  {
  if ( is_dir($rep = 'sauvegarde') && is_executable('sauvegarde') && is_writable('sauvegarde') )  {
    // Sauvegarde de la table complète une seule fois par mois
    $mois = date('Y-m');
    $heure = date('d/m/Y à H:i:s');
    if ( !file_exists("$rep/$table.$mois.php") )  {
      $s = <<<FIN
  <?php exit(); ?>
-- Sauvegarde complète de la table $table le $heure
TRUNCATE `$table`; 
FIN;
      $resultat = $mysqli->query("SHOW COLUMNS FROM `$table`");
      $s1 = "INSERT INTO $table (";
      while ( $r = $resultat->fetch_row() )
        $s1 .= "`${r[0]}`,";
      $s1 = substr($s1,0,-1).') VALUES';
      $resultat->free();
      // Récupération des données
      $resultat = $mysqli->query("SELECT * FROM `$table`");
      if ( $resultat->num_rows )  {
        while ( $r = $resultat->fetch_row() )
          $s1 .= "\n  ('".  str_replace('SEPARATEUR','\',\'',addslashes(implode('SEPARATEUR',$r)))  .'\'),';
        $s1 = substr($s1,0,-1).';';
        $resultat->free();
      }
      else
        $s1 = '-- Table vide !';
      $fichier = fopen("$rep/$table.$mois.php",'wb');
      fwrite($fichier, "$s\n$s1\n");
    }
    else
      $fichier = fopen("$rep/$table.$mois.php",'ab');
    // Éxécution de la requête
    $resultat = $mysqli->query($requete);
    // Sauvegarde systématique de la requête
    if ( isset($_SESSION['login'])  )
      fwrite($fichier, "\n-- Requête de ${_SESSION['login']} (${_SESSION['ip']}) le $heure\n$requete; -- ".$mysqli->affected_rows." ligne(s) affectée(s)\n");
    else  {
      $login = ( isset($GLOBALS['utilisateur']) ) ? $GLOBALS['utilisateur']['login'] : $GLOBALS['login'];
      fwrite($fichier, "\n-- Requête de $login (${_SERVER['REMOTE_ADDR']}) le $heure\n$requete; -- ".$mysqli->affected_rows." ligne(s) affectée(s)\n");
    }
    fclose($fichier);
  }
  return $resultat;
}

// Fonction de mise à jour des informations récentes
function recent($mysqli,$type,$id,$prop=array())  {
  // type : 1->informations, 2->programmes de colles, 3->documents
  // id : celui de l'information/le programme de colles/le document

  // Ajout/modification dans la base de données, suppression si données vides
  if ( $prop )  {
    $requete = 'id='.($type*1000+$id).', heure = NOW()';
    if ( isset($prop['titre']) )
      $requete .= ", titre = '${prop['titre']}'";
    if ( isset($prop['lien']) )
      $requete .= ", lien = '${prop['lien']}'";
    if ( isset($prop['texte']) )
      $requete .= ", texte = '${prop['texte']}'";
    if ( isset($prop['matiere']) )
      $requete .= ", matiere = '${prop['matiere']}'";
    if ( isset($prop['protection']) )
      $requete .= ", protection = '${prop['protection']}'";
    requete('recents',"REPLACE INTO recents SET $requete",$mysqli);
  }
  else
    requete('recents','DELETE FROM recents WHERE id = '.($type*1000+$id),$mysqli);
  
  // Pas la peine d'aller plus loin si la table n'a pas été modifiée.
  if ( !($mysqli->affected_rows) )
    return;

  // Nettoyage des anciennes entrées
  $mysqli->query('DELETE FROM recents WHERE DATEDIFF(NOW(),heure) > 30');
  // Mise dans l'ordre, les plus récents en premier
  $mysqli->query('ALTER TABLE recents ORDER BY heure DESC');
  // Regénération des flux
  rss($mysqli);
  if ( isset($prop['matiere']) )  {
    if ( $prop['matiere'] )
      rss($mysqli,$prop['matiere'],0);
  }
  else  {
    $resultat = $mysqli->query('SELECT GROUP_CONCAT(id) FROM matieres');
    $r = $resultat->fetch_row();
    $resultat->free();
    $matieres = explode(',',$r[0]);
    foreach ( $matieres as $m )
      rss($mysqli,$m,0);
  }
}

// Fonction de mise à jour des flux RSS
// $matieres doit être soit zéro, soit un identifiant de matière, soit une
// chaine contenant 0 et des identifiants séparés par des virgules
// Si $matieres est nul : flux global toutes matières sans autorisation
// Si $matieres est un identifiant : flux avec ou sans autorisation
// Si $matieres est une chaine : flux avec autorisation obligatoire
function rss($mysqli,$matieres='0',$autorisation=0)  {
  // Titre du flux : titre du site
  $resultat = $mysqli->query('SELECT titre FROM pages WHERE id = 1');
  $r = $resultat->fetch_row();
  $resultat->free();
  $titre = $r[0].' - Flux RSS';
  // Description
  if ( $matieres )  {
    $resultat = $mysqli->query("SELECT GROUP_CONCAT(nom SEPARATOR ', ') FROM matieres WHERE FIND_IN_SET(id,$matieres) ORDER BY ordre");
    $r = $resultat->fetch_row();
    $resultat->free();
    $description = "$titre - ${r[0]}";
  }
  else
     $description = $titre;

  // Regénération du flux RSS
  $rep = 'documents/rss/'.sha1($GLOBALS['base'].$autorisation.$matieres);
  $d = date(DATE_RSS);
  $rss = <<<FIN
<?xml version="1.0" encoding="UTF-8"?>
<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">
  <channel>
    <title>$titre</title>
    <atom:link href="http://${GLOBALS['site']}/$rep/rss.xml" rel="self" type="application/rss+xml" />
    <link>http://${GLOBALS['site']}</link>
    <description>$description</description>
    <lastBuildDate>$d</lastBuildDate>
    <language>fr-FR</language>


FIN;
  // Récupération des items
  if ( !$matieres )
    $requete = '';
  elseif ( is_numeric($matieres) )
    $requete = "WHERE matiere = $matieres".( ($autorisation) ? " AND protection <= $autorisation" : '' );
  else
    $requete = "WHERE matiere = $matieres AND protection <= $autorisation";
  $resultat = $mysqli->query("SELECT UNIX_TIMESTAMP(heure) AS heure, titre, lien, texte, protection FROM recents $requete");
  while ( $r = $resultat->fetch_assoc() )  {
    $d = date(DATE_RSS,$r['heure']);
    $titre = preg_replace('/^<.*span> /','',$r['titre']);
    // Si non connecté et document protégé
    if ( !$autorisation && $r['protection'] )
      $texte = "<a href=\"http://${GLOBALS['site']}/${r['lien']}\">".strip_tags($r['titre']).'</a>';
    else
      $texte = preg_replace('/href="([^h])/',"href=\"http://${GLOBALS['site']}/\\1",$r['texte']);
    $rss .= <<<FIN
    <item>
      <title><![CDATA[$titre]]></title>
      <link>http://${GLOBALS['site']}/${r['lien']}</link>
      <guid isPermaLink="false">${r['heure']}</guid>
      <description><![CDATA[$texte]]></description>
      <pubDate>$d</pubDate>
    </item>


FIN;
  }
  $rss .= <<<FIN
  </channel>
</rss>

FIN;

  // Mise à jour du flux RSS
  if ( !is_dir($rep) )
    mkdir($rep,0777,true);
  $fichier = fopen($rep.'/rss.xml','wb');
  fwrite($fichier, $rss);
  fclose($fichier);
}

////////////
/// HTML ///
////////////

// En-têtes HTML et début de page
function debut($mysqli,$titre,$message,$autorisation,$actuel=false,$matiere=false)  {
  // Menu seulement si $actuel non vide
  if ( $actuel )  {
    // Récupération et affichage des pages
    $menu = "<a class=\"icon-menu\" title=\"Afficher le menu\"></a>\n<div id=\"colonne\">\n  <nav>\n";
    if ( !$autorisation )
      $resultat = $mysqli->query('SELECT cle, nom FROM pages WHERE mat = 0 AND protection < 5');
    elseif ( $autorisation == 4 )
      $resultat = $mysqli->query('SELECT cle, nom FROM pages WHERE mat = 0');
    else 
      $resultat = $mysqli->query("SELECT cle, nom FROM pages WHERE mat = 0 AND (id = 1 OR protection <= $autorisation)");
    $r = $resultat->fetch_assoc();
    // Page d'accueil
    $menu .= "    <a class=\"icon-accueil\" href=\".?${r['cle']}\" title=\"${r['nom']}\"></a>\n";
    // Impression et rss
    $menu .= "    <a class=\"icon-imprime\" title=\"Imprimer cette page\" onclick=\"window.print();return false;\"></a>
    <a class=\"icon-rss\" href=\"rss\" title=\"Voir les flux RSS disponibles\"></a>\n";
    // Préférences (élèves, colleurs, professeurs)
    if ( $autorisation > 1 )
      $menu .= "    <a class=\"icon-prefs\" title=\"Gérer ses préférences\" href=\"prefs\"></a>\n";
    // Mail (colleurs, professeurs)
    if ( $autorisation > 2 )
      $menu .= "    <a class=\"icon-mail\" title=\"Envoyer un mail\" href=\"mail\"></a>\n";
    // Connexion/Déconnexion
    $menu .= ( $autorisation ) ? "    <a class=\"icon-deconnexion\" title=\"Se déconnecter\"></a>\n  <hr>\n" : "    <a class=\"icon-connexion\" title=\"Se connecter\"></a>\n  <hr>\n";
    // Autres pages
    while ( $r = $resultat->fetch_assoc() )
      $menu .= "    <a href=\".?${r['cle']}\">${r['nom']}</a>\n";
    $resultat->free();
    // Page de téléchargement
    $menu .= "    <a href=\"docs\">Documents à télécharger</a>\n";
    $resultat = $mysqli->query('SELECT id, nom FROM reps WHERE matiere = 0 AND menu = 1'. ( $autorisation ? " AND protection <= $autorisation" : ' AND protection < 5' ));
    if ( $resultat->num_rows )  {
      while ( $r = $resultat->fetch_assoc() )
        $menu .= "      <a class=\"menurep\" href=\"docs?rep=${r['id']}\">${r['nom']}</a>\n";        
      $resultat->free();
    }
    // Récupération et affichage des matières
    // Non connecté : on voit tout ce qui est non vide
    // Prof : on voit tout ce qui est non vide + on liste les matières associées
    // Invité/Élèves/Colleurs : on voit ce qui est non vide et autorisé
    if ( !$autorisation )
      $resultat = $mysqli->query("SELECT m.id, m.cle, m.nom, m.colles, m.cdt, m.docs, 0 AS notes, GROUP_CONCAT(CONCAT(m.cle,'/',p.cle) SEPARATOR '//') AS pcle, GROUP_CONCAT(p.nom SEPARATOR '//') AS pnom
                                  FROM matieres AS m LEFT JOIN (SELECT * FROM pages WHERE protection < 5) AS p ON p.mat = m.id
                                  WHERE m.colles+m.cdt+m.docs OR p.nom IS NOT NULL GROUP BY m.id ORDER BY m.ordre, p.ordre");
    elseif ( $autorisation == 4 )
      $resultat = $mysqli->query("SELECT m.id, m.cle, m.nom, m.colles, m.cdt, m.docs, m.notes, GROUP_CONCAT(CONCAT(m.cle,'/',p.cle) SEPARATOR '//') AS pcle, GROUP_CONCAT(p.nom SEPARATOR '//') AS pnom
                                  FROM matieres AS m LEFT JOIN (SELECT * FROM pages WHERE protection < 5 OR FIND_IN_SET(mat,'${_SESSION['matieres']}')) AS p ON p.mat = m.id
                                  WHERE m.colles+m.cdt+m.docs+m.notes OR p.nom IS NOT NULL OR FIND_IN_SET(m.id,'${_SESSION['matieres']}') GROUP BY m.id ORDER BY m.ordre, p.ordre");
    else  {
      if ( $autorisation == 1 )
        $notes = '0';
      elseif ( $autorisation == 2 )
        $notes = 'notes';
      elseif ( $autorisation == 3 )
        $notes = '2';
      $resultat = $mysqli->query("SELECT m.id, m.cle, m.nom, (colles AND colles_protection<=$autorisation ) AS colles,
                                  (cdt AND  cdt_protection<=$autorisation ) AS cdt, (docs AND r.protection<=$autorisation ) AS docs,
                                  $notes AS notes, GROUP_CONCAT(CONCAT(m.cle,'/',p.cle) SEPARATOR '//') AS pcle, GROUP_CONCAT(p.nom SEPARATOR '//') AS pnom
                                  FROM matieres AS m LEFT JOIN (SELECT * FROM pages WHERE protection <=$autorisation ) AS p ON p.mat = m.id LEFT JOIN reps AS r ON r.matiere = m.id AND r.parent = 0
                                  WHERE FIND_IN_SET(m.id,'${_SESSION['matieres']}') AND ( $notes OR (docs AND r.protection<=$autorisation ) OR (colles AND colles_protection<=$autorisation ) OR (cdt AND cdt_protection<=$autorisation ) OR p.nom IS NOT NULL )
                                  GROUP BY m.id ORDER BY m.ordre, p.ordre");
    }
    if ( $resultat->num_rows )  {
      while ( $r = $resultat->fetch_assoc() )  {
        $edition = ( $autorisation == 4 ) && ( in_array($r['id'],explode(',',$_SESSION['matieres'])) );
        if ( $edition )  {
          $menu .= "    <h3><span class=\"icon-edite\"></span>${r['nom']}</h3>\n";
          $r['colles'] = $r['cdt'] = $r['docs'] = $r['notes'] = 1;
        }
        else
          $menu .= "    <h3>${r['nom']}</h3>\n";
        if ( !is_null($r['pcle']) )  {
          $pcle = explode('//',$r['pcle']);
          $pnom = explode('//',$r['pnom']);
          $nom = $pnom[0];
          foreach ( $pcle as $cle )  {
            $menu .= "    <a href=\".?$cle\">$nom</a>\n";
            $nom = next($pnom);
          }
        }
        if ( $r['colles'] )
          $menu .= "    <a href=\"colles?${r['cle']}\">Programme de colles</a>\n";
        if ( $r['cdt'] )  {
          $menu .= "    <a href=\"cdt?${r['cle']}\">Cahier de texte</a>\n";
          if ( $edition && ( substr($actuel,0,3) == 'cdt' ) && ( substr($actuel,-strlen($r['cle'])-1) == "?${r['cle']}" ) )
            $menu .= "      <a class=\"menurep\" href=\"cdt-seances?${r['cle']}\">Types de séances</a>\n      <a class=\"menurep\" href=\"cdt-raccourcis?${r['cle']}\">Raccourcis de séances</a>\n";
        }
        if ( $r['docs'] )  {
          $menu .= "    <a href=\"docs?${r['cle']}\">Documents à télécharger</a>\n";
          $resultat_doc = $mysqli->query("SELECT id, nom FROM reps WHERE matiere = ${r['id']} AND menu = 1 AND protection < 5");
          if ( $resultat_doc->num_rows )  {
            while ( $d = $resultat_doc->fetch_assoc() )
              $menu .= "    <a class=\"menurep\" href=\"docs?rep=${d['id']}\">${d['nom']}</a>\n";        
            $resultat_doc->free();
          }
        }
        // Pour les colleurs, $r['notes'] > 1 dans leurs matières associées
        if ( $r['notes'] )
          $menu .= ( $r['notes'] == 1 ) ? "    <a href=\"notes?${r['cle']}\">Notes</a>\n" : "    <a href=\"notes?${r['cle']}\">Notes&nbsp;<span class=\"icon-edite\"></span></a>\n";
      }
      $resultat->free();
    }
    // Liens d'édition
    if ( $autorisation == 4 )
    $menu .= <<<FIN
    <h3>Gestion du site</h3>
    <a href="pages">Les pages</a>
    <a href="utilisateurs">Les utilisateurs</a>
    <a href="groupes">Les groupes d'élèves</a>
    <a href="matieres">Les matières</a>
    <a href="planning">Le planning annuel</a>

FIN;
    $menu = str_replace("a href=\"$actuel\"","a id=\"actuel\" href=\"$actuel\"",$menu);
    $menu .= "\n  </nav>";

    // Affichage des informations récentes
    $recent = '';
    $resultat = $mysqli->query('SELECT titre, lien FROM recents WHERE DATEDIFF(NOW(),heure) < 10'.( ($autorisation) ? " AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')" : '' ).' LIMIT 20');
    if ( $resultat->num_rows )  {
      $menu = "<a class=\"icon-recent\" title=\"Afficher les informations récentes\"></a>\n$menu";
      while ( $r = $resultat->fetch_assoc() )
        $recent .= "\n    <a href=\"${r['lien']}\" title=\"".substr($r['titre'],strpos($r['titre'],'/span>')+7)."\">${r['titre']}</a>";
      $resultat->free();
      $recent = <<<FIN
  <div id="recent">
    <h3>Infos récentes</h3>$recent
  </div>

FIN;
    }
  }
  else
    $menu = $recent = '';
  if ( strlen($menu.$recent) )
    $recent .= "\n</div>";
    
  // RSS
  $rss = sha1($GLOBALS['base'].'00');
  // Message si non vide
  if ( strlen($message) )
    $message = "  <div class=\"warning\">$message</div>\n";
  elseif ( $autorisation == 4 )  {
    $resultat = $mysqli->query('SELECT id FROM utilisateurs WHERE LENGTH(mdp)=41');
    if ( $n = $resultat->num_rows )  {
      $resultat->free();
      $n = ( $n > 1 ) ? "$n comptes" : "1 compte";
      $message = '  <div class="warning">Il y a actuellement '.(( $n > 1 ) ? "$n comptes" : "1 compte").' en attente de validation de votre part. C\'est assez urgent... Il faut aller sur la page de gestion des <a href="utilisateurs">utilisateurs</a> pour les valider.</div>';
    }
  }
  // Token CSRF
  $token = ( isset($_SESSION['csrf-token']) ) ? " data-csrf-token=\"${_SESSION['csrf-token']}\"" : '';
  // Matière
  $matiere = ( $matiere ) ? " data-matiere=\"$matiere\"" : '';
  // Affichage
  echo <<<FIN
<!doctype html>
<html lang="fr">
<head>
  <title>$titre</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, height=device-height, initial-scale=1.0">
  <link rel="stylesheet" href="css/style-min.css?v=2">
  <link rel="stylesheet" href="css/icones-min.css">
  <script type="text/javascript" src="js/jquery.min.js"></script>
  <link rel="alternate" type="application/rss+xml" title="Flux RSS" href="documents/rss/$rss/rss.xml">
  <!--[if lte IE 8]><script src="js/html5shiv.min.js"></script><![endif]--> 
  <!--[if lte IE 8]><script src="js/respond.min.js"></script><![endif]--> 
</head>
<body$token$matiere>
<header><h1>$titre</h1></header>

$menu
$recent

<section>
$message
FIN;
}

// Bas de page
function fin($edition = false, $mathjax = false)  {
  // MathJax chargé seulement si besoin
  $mathjax = ( $mathjax ) ? '
<script type="text/javascript" src="/MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
<script type="text/x-mathjax-config">MathJax.Hub.Config({tex2jax:{inlineMath:[["$","$"],["\\\\(","\\\\)"]]}});</script>' : '';
  // Édition possible si $edition est true
  $js = ( $edition ) ? '<script type="text/javascript" src="js/edition-min.js?v=4"></script>' : '<script type="text/javascript" src="js/fonctions-min.js"></script>';
  // Affichage de message si $_SESSION['message']
  if ( isset($_SESSION['message']) )  {
    $m = json_decode($_SESSION['message'],true);
    $m = "\n<script type=\"text/javascript\">$(window).load( function() { affiche(\"${m['message']}\",'${m['etat']}'); });</script>";
    unset($_SESSION['message']);
  }
  else
    $m = '';
  echo <<<FIN

</section>

<footer>Ce site est réalisé par le logiciel <a href="http://cahier-de-prepa.fr">Cahier de prépa</a>, publié sous <a href="Licence_CeCILL_V2-fr.html">licence libre</a>.</footer>

$js$mathjax$m

</body>
</html>
FIN;
exit();
}

// Affichage des semaines
function format_date($date)  {
  $semaine = array('dimanche','lundi','mardi','mercredi','jeudi','vendredi','samedi');
  $mois = array('','janvier','février','mars','avril','mai','juin','juillet','août','septembre','octobre','novembre','décembre');
  return $semaine[substr($date,0,1)].' '.substr($date,7).' '.$mois[intval(substr($date,5,2))].' '.substr($date,1,4);
}


?>
