/*//////////////////////////////////////////////////////////////////////////////
Éléments JavaScript pour l'utilisation de base de Cahier de Prépa

Copie partielle de edition.js
//////////////////////////////////////////////////////////////////////////////*/

// Notification de résultat de requête AJAX
function affiche(message,etat) {
  $('#log').removeClass().addClass(etat).html(message).show().delay(5000).hide(500);
}

// Affichage d'un placeholder (valeur si élement vide)
// Version simplifiée de celle écrite dans edition.js, valable pour les input
$.fn.placeholder = function() {
  this.each( function() {
    var el = $(this);
    $('<span class="placeholder">'+this.getAttribute('data-placeholder')+'</span>').insertBefore(el).on('click',function() {
      $(this).next().focus();
    }).hide();
    el.on("change keyup mouseup",function() {
      if ( !(this.value.length) && ( $(this).is(':visible') ) )
        $(this).prev().show();
      else
        $(this).prev().hide();
    }).change();
  });
}

///////////////////
// Requêtes AJAX //
///////////////////
$(document).ajaxSend( function(ev,xhr,settings) {
              $('body').css('cursor','wait');
            })
           .ajaxStop( function() {
              $('body').css('cursor','auto');
            })
           .ajaxSuccess( function(ev,xhr,settings) {
              var data = xhr.responseJSON;
              switch (data['etat']) {
                // Si ok, on l'affiche dans le log et on lance la "fonction" de mise à jour de l'affichage
                case 'ok':
                  affiche(data['message'],'ok');
                  settings.fonction(settings.el);
                  break;
                // Si non ok, on l'affiche dans le log et on ne fait rien de plus
                case 'nok':
                  affiche(data['message'],'nok');
                  break;
              }
            });

////////////////////////////////////////////////////////////////////////////
// Modification des éléments (nécessite le chargement complet de la page) //
////////////////////////////////////////////////////////////////////////////
$( function() {

  // Connexion
  $('a.icon-connexion').on('click',function(e) {
    // Div d'affichage des résultats des requêtes AJAX
    if ( !$('#log').length )
      $('<div id="log"></div>').appendTo('body').hide().on("click", function() {
        $(this).hide();
      });

    // On cache le menu si besoin
    $('#colonne,nav').removeClass('visible');
    // Création de fenêtre
    var el = $('<div id="fenetre"></div>').appendTo('body').html('\
<a class="icon-ferme" title="Fermer"></a><a class="icon-ok" title="Valider"></a><h3>Connexion</h3>\
<form>\
  <p>Veuillez entrer votre identifiant et votre mot de passe&nbsp;:</p>\
  <input class="ligne" type="text" name="login" data-placeholder="Identifiant">\
  <input class="ligne" type="password" name="motdepasse" data-placeholder="Mot de passe">\
  <input class="ligne" type="hidden" name="connexion" value="1">\
  <p class="oubli"><a href="connexion?oublimdp">Identifiant ou mot de passe oublié&nbsp;?</a></p>\
  <p class="oubli"><a href="connexion?creationcompte">Créer un compte</a></p>\
</form>').focus();
    // Fond grisé
    $('<div id="fenetre_fond"></div>').appendTo('body').click(function() {
      $('#fenetre,#fenetre_fond').remove();
    });
    // Bouton de fermeture
    $('#fenetre a.icon-ferme').on("click",function() {
      $('#fenetre,#fenetre_fond').remove();
    });
    // Placeholders
    $('#fenetre input').placeholder();
    // Envoi
    $('#fenetre a.icon-ok').on("click",function () {
      $.ajax({url: 'ajax.php', method: "post", data: $('#fenetre form').serialize(), dataType: 'json', el: '', fonction: function(el) { location.reload(true); } })
      .success( function(data) {
        // Si erreur d'identification, on reste bloqué là
        if ( data['etat'] == 'login_nok' )
          $('form p:first').html(data['message']).addClass('warning');
      });
    });
    // Envoi par appui sur Entrée
    $('#fenetre input').on('keypress',function (e) {
      if ( e.which == 13 )
        $('#fenetre a.icon-ok').click();
    });
    // Focus avec du retard pour éviter un bug d'affichage du placeholder
    setTimeout(function() { $('#fenetre input:first').focus() },500);
  });

  // Déconnexion  
  $('a.icon-deconnexion').on('click',function(e) {
    $.ajax({url: 'ajax.php', method: "post", data: { deconnexion:1 }, dataType: 'json', el: '', fonction: function(el) { location.reload(true); } });
  });

  // Menu pour les petits écrans
  $('.icon-menu').on("click", function() {
    $('nav').toggleClass('visible');
    $('#recent').removeClass();
    $('#colonne').toggleClass('visible',$('nav').hasClass('visible'));
  });
  $('.icon-recent').on("click", function() {
    $('#recent').toggleClass('visible');
    $('nav').removeClass();
    $('#colonne').toggleClass('visible',$('#recent').hasClass('visible'));
  });
  
});
