<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs et colleurs connectés uniquement
$mysqli = connectsql();
if ( !$autorisation )  {
  $titre = 'Envoi d\'email';
  $actuel = false;
  include('login.php');
}
elseif ( $autorisation < 3 )  {
  debut($mysqli,'Envoi d\'email','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Envoi d\'email',$message,$autorisation,'mail');

// Récupération des préférences d'envoi (mailexp, mailcopy) de l'utilisateur
$resultat = $mysqli->query("SELECT mail, TRIM(mailexp) AS mailexp, IF(mailcopy,' checked','') AS mailcopy
                            FROM utilisateurs WHERE id = ${_SESSION['id']}");
$u = $resultat->fetch_assoc();
$resultat->free();
echo <<<FIN

  <a class="icon-aide general" data-id="page" title="Aide pour l'envoi de courriel"></a>
  <a class="icon-ok general" title="Envoyer le courriel"></a>

  <article>
    <p><strong>Nom de l'expéditeur&nbsp;: </strong>&nbsp;<span class="editable" data-id="mailprefs|mailexp|0" data-placeholder="Nom">${u['mailexp']}</span>
    <p><strong>Adresse mail de l'expéditeur&nbsp;: </strong>&nbsp;<span class="editable" data-id="mailprefs|mail|0" data-placeholder="Adresse mail">${u['mail']}</span></p>
    <p><strong>Destinataires&nbsp;: </strong>&nbsp;<span class="editabledest"><span>[Personne]</span><a class="icon-edite"></a></span></p>
    <p><strong>Sujet&nbsp;:</strong></p>
    <form id="mail">
      <input class="ligne" name="sujet"></input>
      <p><strong>Texte du message&nbsp;:</strong></p>
      <textarea id="texte" name="texte" rows="20" cols="100">\n\n\n\n-- \n${u['mailexp']}\nhttps://$site/</textarea>
      <p class="ligne"><label for="copie">Recevoir le mail en copie&nbsp;: </label>
        <input type="checkbox" id="copie" name="copie" value="1"${u['mailcopy']}>
      </p>
      <input type="hidden" name="id-copie" value="">
      <input type="hidden" name="id-bcc" value="">
      <input type="hidden" name="envoimail" value="1">
    </form>
  </article>

  <p id="log"></p>

FIN;

// Récupération de tous les utilisateurs
// Utilisateurs non validés : mdp précédé d'une étoile
// Utilisateur vide pour marquer l'arrêt des créations de compte : mdp vide
$resultat = $mysqli->query("SELECT id, autorisation, IF(LENGTH(nom),CONCAT(nom,' ',prenom),CONCAT(login,' (identifiant)')) AS nom, IF(LENGTH(mail),'',' disabled') AS mail
                            FROM utilisateurs WHERE LENGTH(mdp)=40 AND id != ${_SESSION['id']} ORDER BY autorisation DESC, nom");
$a = 0;
$table = '';
while ( $r = $resultat->fetch_assoc() )  {
  if ( $a != $r['autorisation'] )  {
    $a = $r['autorisation'];
    switch ( $a )  {
      case 1 : $t = 'Invités'; break;
      case 2 : $t = 'Élèves'; break;
      case 3 : $t = 'Colleurs'; break;
      case 4 : $t = 'Professeurs'; break;
    }
    $table .= <<<FIN
        <tr><th>$t</th>
            <th><a class="icon-cocher" data-classe="dest_c$a" title="Cocher tous les $t en copie"></a><a class="icon-decocher" data-classe="dest_c$a" title="Décocher tous les $t en copie"></a></th>
            <th><a class="icon-cocher" data-classe="dest_bcc$a" title="Cocher tous les $t en copie cachée"></a><a class="icon-decocher" data-classe="dest_bcc$a" title="Décocher tous les $t en copie cachée"></a></th></tr>

FIN;
  }
  if ( strlen($r['mail']) )
    $r['nom'] .= ' (pas de mail)';
  $table .= "        <tr><td>${r['nom']}</td><td><input type=\"checkbox\" class=\"dest_c$a\" name=\"dest[]\" value=\"${r['id']}\"${r['mail']}></td><td><input type=\"checkbox\" class=\"dest_bcc$a\" name=\"dest_bcc[]\" value=\"${r['id']}\"${r['mail']}></td></tr>\n";
}

// Récupération des groupes d'élèves
$resultat = $mysqli->query('SELECT g.id, g.nom, g.eleves AS eid,
                            GROUP_CONCAT( IF(LENGTH(e.nom),CONCAT(e.prenom," ",e.nom),CONCAT(e.login," (identifiant)")) ORDER BY IF(LENGTH(e.nom),e.nom,e.login) SEPARATOR \', \') AS eleves
                            FROM groupes AS g JOIN utilisateurs AS e ON FIND_IN_SET(e.id,g.eleves) WHERE g.mailnotes%2 GROUP BY g.id ORDER BY g.nom_nat');
if ( $resultat->num_rows )  {
  $table .= "        <tr><th>Groupes d'élèves</th><th></th><th></th></tr>\n";
  while ( $r = $resultat->fetch_assoc() )
    $table .= "        <tr><td>Groupe ${r['nom']}&nbsp;: ${r['eleves']}</td><td><input type=\"checkbox\" class=\"dest\" value=\"${r['eid']}\"></td><td><input type=\"checkbox\" class=\"dest_bcc\" value=\"${r['eid']}\"></td></tr>\n";
  $resultat->free();
}

// Aide et formulaire d'ajout
?>

  <div id="form-utilisateurs">
    <a class="icon-ok" title="Valider ces utilisateurs"></a>
    <h3>Choix des destinataires</h3>
    <table class="destinataires">
      <tbody>
        <tr><th></th><th>Copie</th><th>Copie cachée</th></tr>
<?php echo $table; ?>
      </tbody>
    </table>
  </div>
  
  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>À venir bientôt...</p>
  </div>

<?php
$mysqli->close();
fin(true);
?>
